/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

/* $(document).ready( function() {
	setTimeout( function() {
		$(".tl-ah-date-picker-button:eq(0)").click();
	},300);
}); */

var AJKDatePickerController = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.lightbox = "";
	self.domDatePicker ="";
	self.datePicker = "";
	self.domInput = "";
	self.selectedDate = "";
	self.dateFormatFieldId = "";
	self.formatController = "";
}

AJKDatePickerController.prototype = {
	init: function() {
		var self = this;

		$(".ajk-date-field .tl-ah-input, .ajk-date-field .tlsp-field-input-holder").append('<a href="#" class="tl-ah-date-picker-button">Open date picker</a>');
		$(".ajk-date-field").each( function() {
			var domInput = $(this).find("input").get()[0];
			var domLaunchButton = $(this).find(".tl-ah-date-picker-button").get()[0];
			var dateFormatFieldId = $(this).find(".ajk-date-format-field-id").text();
			$(domLaunchButton).click( function() {
				self.launchLightbox();
				self.domInput = domInput;
				self.dateFormatFieldId = dateFormatFieldId;
				if (self.dateFormatFieldId) {
					$(self.domDateFormat).find("input").val($("#"+self.dateFormatFieldId).val());
					self.formatController.updateFromFieldValue();
					$(self.domDateFormat).css({ display: "block" });	
				}
				else {
					$(self.domDateFormat).css({ display: "none" });	
				}
				self.selectedDate = Date.parse($(domInput).val());
				self.selectedDate = (self.selectedDate) ? self.selectedDate : new Date();
				self.datePicker.setInitialDate({ date: self.selectedDate });
				self.showSelectedDate();
				return false;
			});
		});
		return self;
	},
	launchLightbox: function() {
		var self = this;
		if (!self.lightbox) {
			self.initLightbox();
		}
		self.lightbox.openPanel();
	},
	initLightbox: function() {
		var self = this;
		
		self.generateDatePickerDom();
		
		self.datePicker = new AJKDatePicker({
			domRoot: self.domDatePicker,
			startDateTime: new Date(),
			dayBlockClass: "ajk-dp-day",
			dayBlockSelectedClass: "ajk-dp-day-selected",
			dayBlockTodayClass: "ajk-dp-day-today",
			dayBlockInactiveClass: "ajk-dp-day-hide-visibility",
			domADSelector: $(self.domDatePicker).find(".ajk-dp-ad-button").get()[0],
			domBCSelector: $(self.domDatePicker).find(".ajk-dp-bc-button").get()[0],
			selectedClassForADBC: "ajk-dp-switch-button-selected",
			domYearBox: $(self.domDatePicker).find(".ajk-dp-header input").get()[0],
			domHourBox: $(self.domDatePicker).find(".ajk-dp-hour-field input").get()[0],
			domMinuteBox: $(self.domDatePicker).find(".ajk-dp-minute-field input").get()[0],
			domSecondBox: $(self.domDatePicker).find(".ajk-dp-second-field input").get()[0],
			domSelectedMonthText: $(self.domDatePicker).find(".ajk-dp-header h3").get()[0],
			domNextMonthButton: $(self.domDatePicker).find(".ajk-dp-header a.ajk-dp-next-month").get()[0],
			domPrevMonthButton: $(self.domDatePicker).find(".ajk-dp-header a.ajk-dp-prev-month").get()[0],
			domDayBlockStage: $(self.domDatePicker).find(".ajk-dp-stage").get()[0],
			createDayBlockFunc: function(data) {
				var index = data.index;
				var dayBlockClass = "ajk-dp-day";
				if (index % 7 == 0) {
					dayBlockClass =(dayBlockClass+" "+dayBlockClass+"-left");
				}
				else if (index % 7 == 6) {
					dayBlockClass = (dayBlockClass+" "+dayBlockClass+"-right");
				}
				return $('<a href="#" class="'+dayBlockClass+'"></a>').get()[0];
			},
			callback: function(data) {
				self.selectedDate = data.selectedDate;
				self.datePicker.setInitialDate({ date: self.selectedDate });
				self.showSelectedDate();
			}
		}).init();
		self.lightbox = new TLAdminLightbox({
			domClass: "tl-ah-date-picker-lightbox",
			title: TLConfigText['adminDatePicker_Date_picker'],
			intro: "",
			domContent: self.domDatePicker
		}).init();	
	},
	showSelectedDate: function() {
		var self = this;
		$(self.domSelectedDateText).text(AJKHelpers.formatDate({ formatString: "DD MMM YYYY", date: self.selectedDate, language: "base" }));
	},
	generateDatePickerDom: function() {
		var self = this;
		var inHTML = '<div class="ajk-date-picker">';
		inHTML += '<div class="ajk-dp-header">';
		inHTML += '<h3>July 2008</h3>';
		inHTML += '<a href="#" class="ajk-dp-month-arrow ajk-dp-prev-month">Prev</a>';
		inHTML += '<a href="#" class="ajk-dp-month-arrow ajk-dp-next-month">Next</a>';
		inHTML += '<a href="#" class="ajk-dp-ad-button ajk-dp-switch-button-selected ajk-dp-switch-button">AD</a>';
		inHTML += '<a href="#" class="ajk-dp-bc-button ajk-dp-switch-button">BC</a>';
		
		inHTML += '<div class="tl-ah-input"><div class="tl-ah-f-inner">';
		inHTML += '<input type="text" maxlength="5" class="" />';
		inHTML += '</div><div class="tl-ah-f-right"></div></div>';					
		
		inHTML += '</div>';
		inHTML += '<div class="ajk-dp-middle">';
		inHTML += '<div class="ajk-dp-day-title-holder">';
		inHTML += '<p class="ajk-dp-day-title ajk-dp-day-title-first">'+AJKDatePickerHelper.dateWeekDayArray[1]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[2]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[3]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[4]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[5]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[6]+'</p>';
		inHTML += '<p class="ajk-dp-day-title">'+AJKDatePickerHelper.dateWeekDayArray[0]+'</p>';
		inHTML += '</div>';
		inHTML += '<div class="clear"></div>';
		inHTML += '<div class="ajk-dp-stage">';
		inHTML += '</div>';
		inHTML += '<div class="clear"></div>';
		inHTML += '</div>';
		inHTML += '<div class="ajk-dp-bottom">';
		inHTML += '<div class="ajk-dp-selected-date">';
		inHTML += '<p>'+TLConfigText['adminDatePicker_Selected_date_text']+' <span></span></p>';

		inHTML += '<div class="tl-ah-input ajk-dp-time-field ajk-dp-hour-field"><div class="tl-ah-f-inner">';
		inHTML += '<input type="text" maxlength="2" />';
		inHTML += '</div><div class="tl-ah-f-right"></div></div>';					

		inHTML += '<div class="tl-ah-input ajk-dp-time-field ajk-dp-minute-field"><div class="tl-ah-f-inner">';
		inHTML += '<input type="text" maxlength="2" />';
		inHTML += '</div><div class="tl-ah-f-right"></div></div>';					

		inHTML += '<div class="tl-ah-input ajk-dp-time-field ajk-dp-second-field"><div class="tl-ah-f-inner">';
		inHTML += '<input type="text" maxlength="2" />';
		inHTML += '</div><div class="tl-ah-f-right"></div></div>';					

		inHTML += '</div>';
		
		inHTML += '<div class="ajk-dp-date-format">';
		inHTML += '<p>'+TLConfigText['adminDatePicker_Date_format_text']+'</p>';

		inHTML += '<div class="tl-ah-input tl-ah-dp-date-format-field"><div class="tl-ah-f-inner">';
		inHTML += '<input type="text" />';
		inHTML += '</div><div class="tl-ah-f-right"></div></div>';					

		inHTML += '</div>';

		inHTML += '<div class="tl-ah-form-button-holder">';
		inHTML += '<a href="#" class="rt-button-4 rt-button-align-right ajk-dp-button-confirm">'+TLConfigText['adminDatePicker_Confirm']+'</a>';
		inHTML += '<a href="#" class="rt-button-4 rt-button-align-right ajk-verifier-revert ajk-dp-button-cancel">'+TLConfigText['adminBasic_Cancel']+'</a>';
		inHTML += '<div class="tl-clear"></div>';
		inHTML += '</div>';
		
		inHTML += '</div>';
		inHTML += '</div>';
		self.domDatePicker = $(inHTML).get()[0];
		self.domSelectedDateText = $(self.domDatePicker).find(".ajk-dp-selected-date span").get()[0];
		
		$(self.domDatePicker).find(".ajk-dp-button-confirm").click( function() {
			self.lightbox.closePanel();
			$(self.domInput).val(AJKHelpers.formatDate({ formatString: "DD MMM YYYY HH:mm:ss", date: self.selectedDate, language: "base" }));
			$(self.domInput).blur();
			if (self.dateFormatFieldId) {
				var dateFormat = $(self.domDateFormat).find("input").val();
				$("#"+self.dateFormatFieldId).val(dateFormat).blur();
			}
			return false;
		});

		$(self.domDatePicker).find(".ajk-dp-button-cancel").click( function() {
			self.lightbox.closePanel();
			return false;
		});

		self.domDateFormat = $(self.domDatePicker).find(".ajk-dp-date-format").get()[0];
		
		if (typeof TLDateFormatterField != "undefined") {
			self.formatController = new TLDateFormatterField({ 
				domRoot: self.domDateFormat
			 }).init()
		}
	}
}

var AJKDatePicker = function(data) {
	var self = this;
	self.selectedDateTime = data.startDateTime;
	self.dayBlockClass = data.dayBlockClass;
	self.dayBlockInactiveClass = data.dayBlockInactiveClass;
	self.domRoot = data.domRoot;
	self.domADSelector = data.domADSelector;
	self.domBCSelector = data.domBCSelector;
	self.selectedClassForADBC = data.selectedClassForADBC;
	self.isAD = true;
	self.domSelectedMonthText = data.domSelectedMonthText;  
	self.domNextMonthButton = data.domNextMonthButton;
	self.domPrevMonthButton = data.domPrevMonthButton;
	self.domDayBlockStage = data.domDayBlockStage;
	self.createDayBlockFunc = data.createDayBlockFunc;
	self.domYearBox = data.domYearBox;
	self.domHourBox = data.domHourBox;
	self.domMinuteBox = data.domMinuteBox;
	self.domSecondBox = data.domSecondBox;
	self.domDayBlocks = new Array();
	self.callback = data.callback;
	self.dateUsedForVisibleMonth = "";
	self.arrayDayKeyCells = "";
}

AJKDatePicker.prototype = {
	init: function() {
		var self = this;
		
		self.generateHTML();
		$(self.domNextMonthButton).click( function() {
			self.displayNextMonth();
			return false;
		});
		$(self.domPrevMonthButton).click( function() {
			self.displayPrevMonth();
			return false;
		});
		$(self.domDayBlocks).click( function() {
			var selectedDay = $(this).text();
			if (selectedDay && selectedDay != "null") {
				self.dayWasClicked({ day: selectedDay });	
			}
			return false;
		});
		self.updateDisplayedMonth( {
			date: self.selectedDateTime
		});
		
		self.initYearBox();
		self.initADBC();

		return self;
	},
	initYearBox: function() {
		var self = this;
		
		$([self.domYearBox, self.domHourBox, self.domMinuteBox,self.domSecondBox]).keydown( function(e) {
			var c = e.keyCode;
			if ((c >= 48 && c <=57) || c == 8 || c == 13 || c == 9 || c == 37 || c == 39 || c == 46 || c == 17 || c == 18) {
				return true;
			}
			else {
				return false;	
			}
		}).keyup( function(e) {
			
			if (this == self.domYearBox) {
				var newDate = AJKHelpers.cloneDate({ date: self.dateUsedForVisibleMonth });
				var year = parseInt($(this).val(),10);
				newDate.setFullYear(AJKHelpers.quadrupleDigitNum({ num: year }));
				self.updateDisplayedMonth( {
					date: newDate,
					cancelDateTimeBoxUpdate: true
				});
			}
			else {
				if (this == self.domHourBox) {
					var hour = parseInt($(this).val(),10);
					if (hour > 23) {
						$(this).val(23)
						hour = 23;
					}
					self.selectedDateTime.setHours(hour);
					self.dateUsedForVisibleMonth.setHours(hour);
				}
				else if (this == self.domMinuteBox) {
					var minute = parseInt($(this).val(),10);
					if (minute > 59) {
						$(this).val(59)
						hour = 59;
					}
					self.selectedDateTime.setMinutes(minute);
					self.dateUsedForVisibleMonth.setMinutes(minute);
				}
				else if (this == self.domSecondBox) {
					var second = parseInt($(this).val(),10);
					if (second > 59) {
						$(this).val(59)
						second = 59;
					}
					self.selectedDateTime.setSeconds(second);
					self.dateUsedForVisibleMonth.setSeconds(second);
				}
			}
			
		});
		
	},
	setInitialDate: function(data) {
		var self = this;
		self.selectedDateTime = AJKHelpers.cloneDate({ date: data.date }); 
		self.updateDisplayedMonth({
			date: data.date		
		});
	},
	generateHTML: function() {
		var self = this;
				
		for (var counter = 0; counter < 42; counter++) {
			self.domDayBlocks.push(self.createDayBlockFunc({ index: counter }));
		}
		$(self.domDayBlockStage).html(self.domDayBlocks);

	},
	initADBC: function() {
		var self = this;
		$(self.domADSelector).click( function() {
			if (!self.isAD) {
				self.isAD = true;
				$(this).addClass(self.selectedClassForADBC);	
				$(self.domBCSelector).removeClass(self.selectedClassForADBC);
				self.updateADBC();
			}
			return false;
		});
		$(self.domBCSelector).click( function() {
			if (self.isAD) {
				self.isAD = false;
				$(this).addClass(self.selectedClassForADBC);	
				$(self.domADSelector).removeClass(self.selectedClassForADBC);
				self.updateADBC();
			}
			return false;
		});
	},
	updateADBC: function() {
		var self = this;
		var yearText =  parseInt($(self.domYearBox).val(),10);
		if (!self.isAD) {
			yearText = -yearText;
		}
		var newDate = AJKHelpers.cloneDate({ date: self.dateUsedForVisibleMonth });
		newDate.setFullYear(yearText);
		self.updateDisplayedMonth( {
			date: newDate,
			cancelDateTimeBoxUpdate: true
		});

	},
	updateDisplayedMonth: function(data) {
		var self = this;
		self.dateUsedForVisibleMonth = data.date;
		$(this.domSelectedMonthText).text(AJKDatePickerHelper.monthsArray[self.dateUsedForVisibleMonth.getMonth()]);
		
		var fullYear = self.dateUsedForVisibleMonth.getFullYear();
		if (!data.cancelDateTimeBoxUpdate) {
			var displayYear = AJKHelpers.quadrupleDigitNum({ num: Math.abs(fullYear) });
			var displayHour = AJKHelpers.doubleDigitNum({ num: self.dateUsedForVisibleMonth.getHours() });
			var displayMinute = AJKHelpers.doubleDigitNum({ num: self.dateUsedForVisibleMonth.getMinutes() });
			var displaySecond = AJKHelpers.doubleDigitNum({ num: self.dateUsedForVisibleMonth.getSeconds() });
			$(self.domYearBox).val(displayYear);
			$(self.domHourBox).val(displayHour);
			$(self.domMinuteBox).val(displayMinute);
			$(self.domSecondBox).val(displaySecond);
		}
		if (fullYear < 0) {
			$(self.domADSelector).removeClass(self.selectedClassForADBC);
			$(self.domBCSelector).addClass(self.selectedClassForADBC);
			self.isAD = false;
		}
		else {
			$(self.domADSelector).addClass(self.selectedClassForADBC);
			$(self.domBCSelector).removeClass(self.selectedClassForADBC);
			self.isAD = true;
		}
		
		self.arrayDayKeyCells = new Array();

		var calendarArray = AJKDatePickerHelper.getDayArrayForMonthOfYear({
			date: self.dateUsedForVisibleMonth
		});
		
		var dayOccuredOn = false;

		for (var counter = 0; counter <= 41; counter++) {
			var thisCell = this.domDayBlocks[counter];
			var thisDay = calendarArray[counter];
									
			if (thisDay) {
				dayOccuredOn = counter;
				var keyStr = AJKDatePickerHelper.leadingZero(thisDay)+"/"+AJKDatePickerHelper.leadingZero(self.dateUsedForVisibleMonth.getMonth())+"/"+self.dateUsedForVisibleMonth.getFullYear();
				this.arrayDayKeyCells[keyStr] = thisCell;
				$(thisCell)
				.text(thisDay)
				.removeClass(self.dayBlockInactiveClass)
				.removeClass("ajk-dp-day-hide-display")
				.removeClass("ajk-dp-day-selected")
				.removeClass("ajk-dp-day-today");
				var todaysDate = new Date();
				if (thisDay == todaysDate.getDate() && self.dateUsedForVisibleMonth.getMonth() == todaysDate.getMonth() && self.dateUsedForVisibleMonth.getFullYear() == todaysDate.getFullYear()) {
					$(thisCell).addClass("ajk-dp-day-today");
				}
				if (thisDay == self.selectedDateTime.getDate() && self.dateUsedForVisibleMonth.getMonth() == self.selectedDateTime.getMonth() && self.dateUsedForVisibleMonth.getFullYear() == self.selectedDateTime.getFullYear()) {
					$(thisCell).addClass("ajk-dp-day-selected");
				}
			}
			else {
				var hideClass = (dayOccuredOn && counter >= (dayOccuredOn - (dayOccuredOn % 7)+7) ) ? "ajk-dp-day-hide-display" : self.dayBlockInactiveClass;
				$(thisCell)
				.text("null")
				.removeClass(self.dayBlockInactiveClass)
				.removeClass("ajk-dp-day-hide-display")
				.removeClass("ajk-dp-day-selected")
				.removeClass("ajk-dp-day-today")
				.addClass(hideClass);
			}
			
		} 
		return self;
	},
	displayNextMonth: function() {
		var self = this;
		var newDate = new Date();
		newDate.setTime(self.dateUsedForVisibleMonth.getTime());

		if ((newDate.getMonth + 1) > 11) {
			newDate.setMonth(0);
			newDate.setYear(newDate.getFullYear()+1);
		}
		else {
			newDate.setMonth(newDate.getMonth()+1);
		}
		
		self.updateDisplayedMonth( {
			date: newDate
		});
	},
	displayPrevMonth: function() {
		var self = this;
		var newDate = new Date();
		newDate.setTime(self.dateUsedForVisibleMonth.getTime());

		if ((newDate.getMonth - 1) < 0) {
			newDate.setMonth(11);
			newDate.setYear(newDate.getFullYear()-1);
		}
		else {
			newDate.setMonth(newDate.getMonth()-1);
		}

		self.updateDisplayedMonth( {
			date: newDate
		});
	},
	dayWasClicked: function(data) {
		var self = this;
		self.dateUsedForVisibleMonth.setDate(data.day);
		self.callback({
			selectedDate: self.dateUsedForVisibleMonth
		});
	}
}

var AJKDatePickerHelper = {
	dateWeekDayArray: AJKHelpers.dateWeekDayShortArray,
	daysArray: AJKHelpers.dateWeekDayArray,
	daysShortArray: AJKHelpers.dateWeekDayShortArray,
	monthsArray: AJKHelpers.dateMonthsArray,
	monthsSemiShortArray: AJKHelpers.dateMonthsShortArray,
	monthsShortArray: AJKHelpers.dateMonthsShortArray,
	daySuffixArray: AJKHelpers.dateDaySuffixArray,
	oneDayInMS: 1000*60*60*24,
	getDayOfWeekStrForDate: function(data) {
		var thisDate = data.date;
		var dayVersion = data.dayVersion;
		var dayOfWeek = thisDate.getDay();
		if (dayVersion == "short") {
			return this.daysShortArray[dayOfWeek];
		}
		else {
			return this.daysArray[dayOfWeek];
		}
	},
	leadingZero: function(nr) {
		if (nr < 10 && nr > 0) {
			nr = "0" + nr;
		}
		else if (nr == 0) {
			nr="00";
		}
		return nr;
	},
	getDayArrayForMonthOfYear: function(data) {
		var selectedMonth = data.date.getMonth();
		var selectedYear = data.date.getFullYear();
				
		var FOM = new Date(selectedYear,selectedMonth,1);
		var FOMWeekDay=FOM.getDay();

		var FOMDayOffset=FOMWeekDay-1;
		if (FOMDayOffset==-1) {
		    FOMDayOffset=6;
		}
		var nextMonth = new Date(selectedYear,(selectedMonth+1),1);
		var FOMMonthLength=Math.round(((nextMonth-FOM)/this.oneDayInMS));
		var LDOM = new Date();
		LDOM.setFullYear(selectedYear,selectedMonth,FOMMonthLength);
		var LDOMDayOffset=7-LDOM.getDay();
		if (LDOMDayOffset==7) {
			LDOMDayOffset=0;
		}
		var calendarArray = new Array();
		for (var counter=0; counter<FOMDayOffset; counter++) {
		    calendarArray[calendarArray.length]="";
		}
		for (var counter2=0; counter2<FOMMonthLength; counter2++) {
		    calendarArray[calendarArray.length]=(counter2+1);
		}
		for (var counter3=0; counter3<LDOMDayOffset; counter3++) {
		    calendarArray[calendarArray.length]="";
		}
		return calendarArray;
	}
}