/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

/* BUG SOLVE
 *
 * This code solves many problems related to when IE6 users have page loads set to always
 ************************************************************************************************/
try {
  document.execCommand("BackgroundImageCache", false, true);
} catch(err) {}

/* IE6 Array indexof functionality */
if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function(value, start) {
		var arrayLength = this.length;
		var start = (!start) ? 0 : start; 
		for (var i=start; i<arrayLength; i++) {
			if (this[i] == value) {
				return i;
			}
		}
		return -1;
	}
}

/* We extend the datejs-js date object - see datejs-en.js to deal with BC and AD */
Date.parseOrig = Date.parse;
Date.parse = function(input) {
	if (typeof input === "string") {
		input = input.replace("ad","").replace("AD","");
		var isBC = (input.toLowerCase().indexOf("bc") !=-1);
		input = input.replace("bc","").replace("BC","");
		var largeYear = Date.AJKIsStringLargeYear(input);
		
		if (largeYear) {
			var retDate = new Date();
			if (isBC) {
				retDate.setFullYear(-largeYear);
			}
			else {
				retDate.setFullYear(largeYear);
			}
			return retDate;
		} 
		else if (isBC) {
			var aDate = Date.parseOrig(input);
			if (!aDate) {
				return aDate;
			}
			aDate.setFullYear(-aDate.getFullYear());
			return aDate;
		}
		else {
			return Date.parseOrig(input);
		}
	}
	else {
		return Date.parseOrig(input);
	}
}

Date.STANDARDMAXFULLYEAR = 99999;
Date.MAXFULLYEAR = 999999999999;
Date.AJKLongDateActive = true;

Date.AJKIsStringLargeYear = function(input) {
	input = input.replace(/ /g,"").replace(/,/g,"");
	if (parseInt(input,10) == input && input > Date.STANDARDMAXFULLYEAR && input < Date.MAXFULLYEAR) {
		return input;	
	}
	return false;
}

Date.prototype.origSetFullYear = Date.prototype.setFullYear;
Date.prototype.setFullYear = function(fullYear) {
	if (fullYear > Date.STANDARDMAXFULLYEAR || fullYear <  -Date.STANDARDMAXFULLYEAR) {
		this.setFullYear(0);
		this.ajkLongDate = true;
		this.ajkLongDateYear = fullYear;
	}
	else {
		this.ajkLongDate = false;
		return this.origSetFullYear(fullYear);
	}
}

Date.prototype.origGetFullYear = Date.prototype.getFullYear;
Date.prototype.getFullYear = function(fullYear) {
	return (this.ajkLongDate) ? this.ajkLongDateYear :  this.origGetFullYear();
}

Date.prototype.origGetTime = Date.prototype.getTime;
Date.prototype.getTime = function(data) {
	if (!Date.AJKLongDateActive) {
		return this.origGetTime(data);
	}
	else {
		return (this.ajkLongDate) ? (this.ajkLongDateYear-1970) * AJKHelpers.dateOneYearInMS :  this.origGetTime();
	}
}

Date.prototype.origSetTime = Date.prototype.setTime;
Date.prototype.setTime = function(data) {
	if (!Date.AJKLongDateActive) {
		return this.origSetTime(data);
	}
	else {
		var fullYear = data/AJKHelpers.dateOneYearInMS+1970;
		if (fullYear > Date.STANDARDMAXFULLYEAR || fullYear <  -Date.STANDARDMAXFULLYEAR) {
			this.ajkLongDate = true;
			this.ajkLongDateYear = fullYear;
		}
		else {
			this.ajkLongDate = false;
			return this.origSetTime(data);
		}
	}
}

var AJKHelpers = {
	iDevice: -1,
	isIDevice: function() {
		if (this.iDevice == -1) {
			this.iDevice = 	(navigator.platform.indexOf("iPhone") != -1) || (navigator.platform.indexOf("iPod") != -1) || (navigator.userAgent.match(/iPad/i) != null);
		}
		return this.iDevice;	
	},
	emptyImage: "assets/ui/empty-image.gif",
	cloudfront: "d8lktyzx0qqvd.cloudfront.net",
	uploadDomain: "tikitokiservices.com",
	getProcessedImageUrlForAccount: function(data) {
		var imgSrc = data.imgSrc;
		var accountType = data.accountType;
		var forceShow = data.forceShow;
		if (imgSrc && imgSrc.indexOf("tikitokiservices.com") != -1) {
			if (accountType == "Standard" && !forceShow) {
				return this.emptyImage;
			}
			else {
				return imgSrc.replace("www."+this.uploadDomain,this.cloudfront).replace(this.uploadDomain,this.cloudfront); // Replace tikitokiservices with amazon cloudfront url	
			}
		}
		else {
			return imgSrc;
		}
	},
	getDataUrlForImage: function(data) {
		var self = this;
		var anImage = data.image;
		var maxSize = data.maxSize;
	    var canvas = document.createElement("canvas");
	    var lWidth = anImage.width;
	    var lHeight = anImage.height;
	    if (maxSize) {
	    	if (lWidth > maxSize.width) {
	    		lHeight = Math.round(maxSize.width/lWidth * lHeight);
	    		lWidth = maxSize.width	
	    	}
	    	if (lHeight > maxSize.height) {
	    		lWidth = Math.round(maxSize.height/lHeight * lWidth);
	    		lHeight = maxSize.height;	
	    	}
	    }
	    canvas.width = lWidth;
	    canvas.height = lHeight;
        $(anImage).css({ width: lWidth });
	    var ctx = canvas.getContext("2d");
	    ctx.drawImage(anImage, 0, 0,lWidth,lHeight);
	    var dataURL = canvas.toDataURL("image/png");
    	return dataURL;
	},
	getTimelineImageUrl: function(data) {
		var imageSrc = data.src;
		
		if (!imageSrc) {
			return data.emptyImage || AJKHelpers.emptyImage;	
		}

		var emptyImage = (data.emptyImage) ? data.emptyImage : theTLSettings.flickrReplacementImage;

		if (imageSrc.indexOf("flickr.com") != -1) {
			var altPath = theTLMainController.timeline.altFlickrImageUrl;
			if (altPath && altPath.indexOf("http://") != -1) {
				var imageUrlSplit = imageSrc.split("/");
				var newImageSrc = altPath+imageUrlSplit[imageUrlSplit.length-1];
				return this.getProcessedImageUrlForAccount({
					imgSrc: newImageSrc,
					accountType: theTLMainController.timeline.accountType,
					forceShow: true
				});	
			}
			else { 
				//return emptyImage;
				return imageSrc;
			}
		}
		else {
			return this.getProcessedImageUrlForAccount({
				imgSrc: imageSrc,
				accountType: theTLMainController.timeline.accountType
			});	
		}
	},
	isFlickrImage: function(data) {
		return (data.src.indexOf("flickr.com") != -1 && !theTLMainController.timeline.altFlickrImageUrl);
	},
	getFKRPhotoPageFromImageSrc: function(data) {
		var imgSplit = data.src.split("/");
		var lastBit = imgSplit[imgSplit.length-1];
		if (lastBit) {
			fkrId = lastBit.split("_")[0];	
			return "http://flickr.com/photo.gne?id="+fkrId;
		}
		return "http://flickr.com";
	},
	convertNumToXDecimalPlaces: function(data) {
		var num = data.num;
		var cnvInt = Math.pow(10,data.x);
		return parseInt(num * cnvInt)/cnvInt;
	},
	stringRepeat: function(data) {
		var aString = data.aString;
		var multiplier = data.multiplier;
    	return new Array(multiplier + 1).join(aString);
	},
	convertHexColourToRGB: function(data) {
		var hexColour = data.hexColour;
		var cutHex = function(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h}
		var hexToR = function(h) {return parseInt((cutHex(h)).substring(0,2),16)}
		var hexToG = function(h) {return parseInt((cutHex(h)).substring(2,4),16)}
		var hexToB = function(h) {return parseInt((cutHex(h)).substring(4,6),16)}
		return {
			r: hexToR(hexColour),
			g: hexToG(hexColour),
			b: hexToB(hexColour)
		}
	},
	generateAudioEmbedHTML: function(data) {
		var self = this;
		var audioSrc = data.src;
		var type = data.type;
		var audioId = data.audioId;
		var colour = data.colour;
				
		if (type == "soundcloud") {
			audioSrc = (audioSrc.split("?"))[0];
			var iHTML = '<object height="100%" width="100%" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000">';
			iHTML += '<param name="movie" value="http://player.soundcloud.com/player.swf?url='+audioSrc+'&auto_play=true&show_artwork=true&theme_color=000000&color='+colour+'"></param>';
  			iHTML += '<param name="allowscriptaccess" value="always"></param>';
  			iHTML += '<embed allowscriptaccess="always" height="100%" src="http://player.soundcloud.com/player.swf?url='+audioSrc+'&auto_play=true&show_artwork=true&theme_color=000000&color='+colour+'" type="application/x-shockwave-flash" width="100%"></embed>';
			iHTML += '</object>';
			return iHTML;
		}
		else if (type == "skoletube") {
			audioSrc = "http://www.skoletube.dk/flvideo/"+AJKHelpers.decode_base64(audioId)+".mp3";
		}
		
		var insertHTML = AJKHelpers.generateJWPlayerVideoEmbedHTML({ videoUrl: audioSrc });
		return insertHTML;
	},
	generateVideoEmbedHTML: function(data) {
		var self = this;
		var vidSrc = data.src;
		var type = data.type;
		type = (type) ? type : "file";
		var width = data.width;
		var height = data.height;
		var videoId = data.videoId;
		var colour = data.colour;
		var theme = (data.theme) ? data.theme : "dark";
		
		
		var autoplay = (data.autoplay) ? 1 : 0;

		var insertHTML = "";
		switch (type) {
			case "vimeo":
				insertHTML='<iframe src="http://player.vimeo.com/video/'+videoId+'?color='+colour+'&autoplay=1&title=0&portrait=0&byline=0&type=html5_desktop_local" width="'+width+'" height="'+height+'" frameborder="0"></iframe>';
				//insertHTML='<video src="http://vimeo.com/play_redirect?clip_id='+videoId+'&#038;quality=hd" controls="controls" width="'+width+'" height="'+height+'"></video>';
				
				/*if ($.browser.msie && $.browser.version < 9) {
					insertHTML += '<embed src="http://vimeo.com/moogaloop.swf?clip_id='+videoId+'&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color='+colour+'&amp;fullscreen=1&amp;autoplay='+autoplay+'" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="'+width+'" height="'+height+'">';
					insertHTML += '</embed>';
				}
				else {
					insertHTML += '<object width="'+width+'" height="'+height+'">';
					insertHTML += '<param name="allowfullscreen" value="true" />';
					insertHTML += '<param name="allowscriptaccess" value="always" />';
					insertHTML += '<param name="movie" value="http://vimeo.com/moogaloop.swf?clip_id='+videoId+'&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color='+colour+'&amp;fullscreen=1&amp;autoplay='+autoplay+'" />';
					insertHTML += '<embed src="http://vimeo.com/moogaloop.swf?clip_id='+videoId+'&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color='+colour+'&amp;fullscreen=1&amp;autoplay='+autoplay+'" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" width="'+width+'" height="'+height+'">';
					insertHTML += '</embed>';
					insertHTML += '</object>';
				}*/
			break;
			case "youtube":
				if ($.browser.msie && $.browser.version < 9) {
					insertHTML = '<embed src="http://www.youtube.com/v/'+videoId+'" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'+width+'" height="'+height+'"></embed>';
				}
				else {
					insertHTML+='<iframe class="youtube-player" type="text/html" width="'+width+'" height="'+height+'" src="http://www.youtube.com/embed/'+videoId+'?theme='+theme+'&html5=1" frameborder="0"></iframe>';
					/*insertHTML = '<object width="'+width+'" height="'+height+'"><param name="movie" value="http://www.youtube.com/v/'+videoId+'"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/'+videoId+'" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'+width+'" height="'+height+'"></embed></object>';*/
				}
			break;
			case "file":
				insertHTML = AJKHelpers.generateJWPlayerVideoEmbedHTML({ videoUrl: vidSrc });
			break;

		}
			
		insertHTML = (insertHTML) ? insertHTML : '<div></div>';
		
		return insertHTML;
	},
	generateJWPlayerVideoEmbedHTML: function(data) {
		var vidUrl = data.videoUrl;
		var insertHTML = "";
		if (this.isIDevice() || 1) { // Always use HTML5 video
			insertHTML +='<video src="'+vidUrl+'" controls autoplay height="100%" width="100%"></video>';
		}
		else if ($.browser.msie && $.browser.version < 9) {
			insertHTML +=	'<embed  type="application/x-shockwave-flash" id="player2" name="player2" src="/assets/jw-player/player-licensed.swf"  width="100%"  height="100%" allowscriptaccess="always"  allowfullscreen="true" flashvars="file='+vidUrl+'&autostart=true"  />';
		}
		else {
			insertHTML += '<object id="player" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" name="player" width="100%" height="100%">';
			insertHTML +=	'<param name="movie" value="/assets/jw-player/player-licensed.swf" />'; 
			insertHTML +=	'<param name="allowfullscreen" value="true" />';
			insertHTML +=	'<param name="allowscriptaccess" value="always" />';
			insertHTML +=	'<param name="flashvars" value="file='+vidUrl+'&autostart=true" /> ';
			insertHTML +=	'<embed  type="application/x-shockwave-flash" id="player2" name="player2" src="/assets/jw-player/player-licensed.swf"  width="100%"  height="100%" allowscriptaccess="always"  allowfullscreen="true" flashvars="file='+vidUrl+'&autostart=true"  />';
			insertHTML +=	'</object>'; 
		}
		return insertHTML; 
	},
	getImageSize: function(data) {
		var imageUrl = data.imageUrl;
		var anImage = new Image();
		anImage.src = imageUrl;
		return {
			width: anImage.width,
			height: anImage.height 	
		}
	},
	sizeImageToFitInBoxOfSize: function(data) { // The image must be loaded
		var domImage = data.domImage;
		var boxSize = data.boxSize;
		var imageSize = data.imageSize;
		var returnScaledImageSize = data.returnScaledImageSize;
		var imageOffset = data.imageOffset;
		
		if (imageOffset && typeof imageOffset.x == "undefined") {
			var newImageOffset = {};
			var splitVal = imageOffset.split(",");
			newImageOffset.x = (splitVal[0]) ? parseFloat(splitVal[0]) : 0;
			newImageOffset.y = (splitVal[1]) ? parseFloat(splitVal[1]) : 0;
			imageOffset = newImageOffset;
		}

		if (!imageSize) {
			imageSize = {
				width: $(domImage).width(),
				height:	$(domImage).height()
			}
		}
		var adjustedDimensions = {
			height: 0,
			width: 0,
			xOffset: 0,
			yOffset: 0	
		}
		
		if (imageSize.width/imageSize.height > boxSize.width/boxSize.height) {
			adjustedDimensions.height = boxSize.height;
			adjustedDimensions.width = Math.round(adjustedDimensions.height/imageSize.height * imageSize.width);
			adjustedDimensions.xOffset = -Math.round((adjustedDimensions.width - boxSize.width)/2);
			adjustedDimensions.yOffset = 0;
		} 
		else {
			adjustedDimensions.width = boxSize.width;
			adjustedDimensions.height = Math.round(adjustedDimensions.width/imageSize.width * imageSize.height);
			adjustedDimensions.yOffset = -Math.round((adjustedDimensions.height - boxSize.height)/2);
			adjustedDimensions.xOffset = 0;
		}
		
		var adjustedAgainDimensions = {
			width: adjustedDimensions.width,
			height: adjustedDimensions.height,
			yOffset: adjustedDimensions.yOffset,
			xOffset: adjustedDimensions.xOffset	
		}
		
		if (imageOffset) {
			var possXOffset = adjustedAgainDimensions.width - boxSize.width;
			adjustedAgainDimensions.xOffset = Math.round(-possXOffset/2 + possXOffset/2 * -imageOffset.x);
			var possYOffset = adjustedAgainDimensions.height - boxSize.height;
			adjustedAgainDimensions.yOffset = Math.round(-possYOffset/2 + possYOffset/2 * -imageOffset.y);
		}
		
		if (domImage) {
			$(domImage).css({
				width: adjustedAgainDimensions.width+"px",
				height: adjustedAgainDimensions.height+"px",
				left: adjustedAgainDimensions.xOffset+"px",
				top: adjustedAgainDimensions.yOffset+"px"
			});
		}
		
		if (returnScaledImageSize) {
			return adjustedDimensions;
		}
	},
	renderCanvasText: function(data) {
		var ctx = data.canvasContext;
		var x = data.textPos.x;
		var y = data.textPos.y;
		var maxWidth = data.maxWidth;
		var maxLines = (data.maxLines) ? data.maxLines : 5000;
		var lineHeight = data.lineHeight;
		var text = data.text;
		var retLines = "";
		var words = text.split(' ');
		var numWords = words.length;
		var lines = data.lines;
		
		if (lines) {
			// Lines already provided, so just echo them out
			
			$.each(lines, function() {
				ctx.fillText(this, x, y);
				y+= lineHeight;
			});
			
		}
		else {
			var line = '';
			retLines = [];
			for(var n = 0; n < numWords; n++) {
				var testLine = line + words[n] + ' ';
				var metrics = ctx.measureText(testLine);
				var testWidth = metrics.width;
				if (testWidth > maxWidth) {
					var cachedLine = line;
					retLines.push(cachedLine);
					ctx.fillText(line, x, y);
					line = words[n] + ' ';
					y += lineHeight;
				}
				else {
					line = testLine;
				}
			}
			if (retLines.length < maxLines) {
				retLines.push(line);
				ctx.fillText(line, x, y);
			}
		}
		return retLines || lines;
	},
	customCreateClickableLinks: function(data) {
		var aString = data.aString;
		var extra = (data.extra) ? data.extra : "";
		var myRegex = /\[(.*)\]\((.*)\)/gim
		return aString.replace(myRegex, function() { 
			// If url is to current page, don't want to open in new window etc so deeplinking works
			extra = (AJKHelpers.isUrlToCurrentPage({ url: RegExp.$2 })) ? "" : extra;
			return '<a '+extra+' href="'+RegExp.$2+'">'+RegExp.$1.replace(/-/g," ")+'</a>' 
		});
	},
	isUrlToCurrentPage: function(data) {
		var aUrl = data.url;
		aUrl = aUrl.split("#")[0];
		if (aUrl == "./") {
			return true;	
		}
		var cUrl = window.location.href.toString();
		cUrl = cUrl.split("#")[0];
		return (cUrl == aUrl);
	},
	createClickableLinks: function(data) {
		var aString = data.aString;
	    return aString
	    .replace(/(ftp|http|https|file):\/\/[\S]+(\b|$)/gim,
	'<a href="$&">$&</a>')
	    .replace(/([^\/])(www[\S]+(\b|$))/gim,
	'$1<a href="http://$2">$2</a>');
	},
	getMousePos: function(data) {
		var event = data.event;
		xPos = yPos = false;
		if (document.layers){
	    	xPos = event.x;
			yPos = event.y;
		}
		else if (document.getElementById){
			xPos = event.clientX;
			yPos = event.clientY;
		}
		return { x: xPos, y: yPos };
	},
	getSelfOrFirstParantOfClass: function(data) {
		var currentDomEl = data.domEl;
		var className = data.className;
		
		while (currentDomEl) {
			if ($(currentDomEl).hasClass(className)) {
				return currentDomEl; 	
			}
			currentDomEl = $(currentDomEl).parent()[0];
		}
		return false;		
		
	},
	generateRandomDate: function(data) {
		var startDate = data.startDate;
		var endDate = data.endDate;
		var diff = endDate.getTime() - startDate.getTime();
		var randNum = Math.floor(Math.random()*diff);
		var retDate = new Date();
		retDate.setTime(startDate.getTime()+randNum);
		return retDate;
	},
	getEmptyDate: function() {
		var date = new Date();
		date.setTime(0);
		return date;	
	},
	cloneDate: function(data) {
		var retDate = new Date();
		retDate.setTime(data.date.getTime());
		return retDate;
	},
	createDateWithTime: function(data) {
		var retDate = new Date();
		retDate.setTime(data.time);
		return retDate;
	},
	getFirstDayOfYearDateForDate: function(data) {
		var aDate = this.createDateWithTime({ time: data.date.getTime() });
		aDate.setDate(1);
		aDate.setMonth(0);
		aDate.setHours(0);
		aDate.setMinutes(0);
		aDate.setSeconds(0);
		aDate.setMilliseconds(0);
		return aDate;
	},
	getFirstDayOfMonthDateForDate: function(data) {
		var aDate = this.createDateWithTime({ time: data.date.getTime() });
		aDate.setDate(1);
		aDate.setHours(0);
		aDate.setMinutes(0);
		aDate.setSeconds(0);
		aDate.setMilliseconds(0);
		return aDate;
	},
	numberOfDaysInMonth: function(data) {
		var aDate = data.aDate;
		var year = aDate.getFullYear();
		var month = aDate.getMonth();
		var tmpStartDate = this.getEmptyDate();
		tmpStartDate.setFullYear(year);
		tmpStartDate.setMonth(month);
		tmpStartDate.setDate(1);
		var nextMonth = (month == 11) ? 0 : month+1;
		var nextYear = (month == 11) ? year+1 : year;
		var tmpEndDate = this.getEmptyDate();		
		tmpEndDate.setFullYear(nextYear);
		tmpEndDate.setMonth(nextMonth);
		tmpEndDate.setDate(1);
		var numDays = Math.round((tmpEndDate.getTime() - tmpStartDate.getTime())/this.dateOneDayInMS);
		return numDays;
	},
	waitForId: function(data) {
		var anObject = data.anObject;
		var callback = data.callback;
		var checkForId = function() {
			if (anObject.id == "awaiting") {
				var thisFunc = arguments.callee;
				setTimeout( function() {
					thisFunc();
				}, 100);	
			}
			else if (callback) {
				callback();
			}
		}
		checkForId();
	},
	cloneObj: function(data) {
		var obj = data.obj
    	if (obj == null || typeof(obj) != 'object') {
        	return obj;
    	}
    	var temp = new obj.constructor(); // changed (twice)
    	for (var key in obj) {
        	temp[key] = this.cloneObj({obj: obj[key] });
    	}
    	return temp;
	},
	jiggleDomEl: function(data) {
		var domEl = data.domEl;
		var displacementFactor = data.displacementFactor;
		var leftOffset = ($(domEl).css("left") && $(domEl).css("left") != "auto") ? parseInt($(domEl).css("left")) : 0;
		var position = $(domEl).css("position");
		if (position != "absolute") {
			$(domEl).css({position: "relative"});
		}
		var numRadians = 16;
		var steps = 25;
		for (var counter = 0; counter <= numRadians; counter+=0.2) {
			(function() {
				var lOffset = leftOffset + Math.cos(counter)*displacementFactor;
				var delay = parseInt(counter * steps);
				setTimeout( function() {
					$(domEl).css({left: lOffset});
					if (Math.abs(delay - (numRadians * steps)) < 5) {
						$(domEl).css({position: position, left: leftOffset});
					}
				}, delay);
			}());	
		}
	},
	flashDomEl: function(data) {
		var	domEl = data.domEl;
		var numRadians = (data.numRadians) ? data.numRadians : 12;
		var steps = 50;
		for (var counter = 0; counter <= numRadians; counter+=0.2) {
			(function() {
				var opacity = Math.cos(counter);
				var delay = parseInt(counter * steps);
				setTimeout( function() {
					$(domEl).css({opacity: 0.3 + 0.7 * opacity});
					if (Math.abs(delay - (numRadians * steps)) < 5) {
						$(domEl).css({opacity: 1 });
					}
				}, delay);
			}());	
		}
	},
	isEmail: function(data) {
		var self = this;
		var aString = data.aString;	
		return aString.match(/^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i);
	},
	cancelSelectionOnDomEl: function(data) {
		var domEl = data.domEl;
	    domEl.onselectstart = function() {
	        return false;
	    };
	    domEl.unselectable = "on";
	    domEl.style.MozUserSelect = "none";
	},
	getCoordsOfDomEl: function(data) {
		var domEl = data.domEl;
		var xPos = yPos = 0;
		if (domEl.offsetParent) {
			xPos = domEl.offsetLeft;
			yPos = domEl.offsetTop;
			while (domEl = domEl.offsetParent) {
				xPos += domEl.offsetLeft;
				yPos += domEl.offsetTop;
			}
		}
		return { x:xPos, y:yPos };
	},
	get4CoordsOfDomEl: function(data) {
		var domEl = data.domEl;
		var coords = this.getCoordsOfDomEl(data);
		coords.x2 = coords.x + $(domEl).width();
		coords.y2 = coords.y + $(domEl).height();
		return coords;
	},
	calculateDomElHeight: function(data) {
		var self;
		var domEl = data.domEl;
		var height = $(domEl).height()
		height += parseInt($(domEl).css("marginTop"));
		height +parseInt($(domEl).css("marginBottom"));
		return height;		
	},
	getNowDate: function() {
		return new Date();	
	},
	trimArray: function(data) {
		var anArray = data.anArray;
		var limit = (anArray.length < data.limit) ? anArray.length : data.limit;
		var counter = 0;
		var retArray = new Array();
		while (counter < limit) {
			retArray.push(anArray[counter++]);
		}
		return retArray;
	},
	dateFromMySQLDate: function(data){
		var dateString = data.dateString;
		if (!dateString || dateString == "undefined") {
			return false;
		}
		var isBC = (dateString.indexOf("BC") != -1);
		dateString = dateString.replace(" BC","").replace("BC","");
		
		var containsMillion = (dateString.indexOf("million") != -1);
		var containsBillion = (dateString.indexOf("billion") != -1);
		if (containsMillion || containsBillion) {
			splitString = (containsMillion) ? dateString.split(" million") : dateString.split(" billion"); 
			var tYear = (containsMillion) ? splitString[0] * 1000000 : splitString[0] * 1000000000;
			dateString = parseInt(tYear)+splitString[1];
		}
		
		// Sample date: 2009-04-13 20:16:58
		var dateAllArray = dateString.split(" ");
		var dateArray = dateAllArray[0].split("-");
		var timeArray = dateAllArray[1].split(":"); 
		//...
		var date = this.getEmptyDate();
		date.setDate(parseInt(dateArray[2],10));
		date.setMonth(parseInt(dateArray[1],10)-1);
		var aYear = parseInt(dateArray[0],10);
		//aYear *=10;
		if (isBC) {
			date.setFullYear(-aYear);
		}
		else {
			date.setFullYear(aYear);
		}
		
		date.setHours(parseInt(timeArray[0],10));
		date.setMinutes(parseInt(timeArray[1],10));
		date.setSeconds(parseInt(timeArray[2],10));

		return date;
	},
	dateMillion: "million", // Overwritten by translation
	dateBillion: "billion",
	dateAD: "AD",
	dateBC: "BC",
	dateWeekDayArray: TLConfigText['basic_weekDays'] ,
	dateWeekDayShortArray: TLConfigText['basic_shortWeekDays'],
	dateMonthsArray: TLConfigText['basic_months'],
	dateMonthsShortArray: TLConfigText['basic_shortMonths'],
	dateDaySuffixArray: TLConfigText['basic_daySuffixes'],
    dateOneHourInMS: 1000*60*60,
    dateOneDayInMS: 1000*60*60*24,
    dateOneYearInMS: 1000*60*60*24*365.2425,
	baseLangDateWeekDayArray: ["Sunday","Monday","Tuesday","Wednesday", "Thursday","Friday","Saturday"],
	baseLangDateWeekDayShortArray: ["Sun","Mon","Tue","Wed", "Thu","Fri","Sat"],
	baseLangDateMonthsArray: ["January","February","March","April","May","June", "July","August","September","October","November","December"],
	baseLangDateMonthsShortArray: ["Jan","Feb","Mar","Apr","May","Jun", "Jul","Aug","Sep","Oct","Nov","Dec"],
	baseLangDateDaySuffixArray: ["st","nd","rd","th","th","th","th","th","th","th","th","th","th","th","th","th","th","th","th","th", "st","nd","rd","th","th","th","th","th","th","th","st","nd","rd","th","th","th","th","th","th","th"],
	baseLangBC: "BC",
	baseLangAD: "AD",
	prettyDateFromMySQLDate: function(data) {
		var jsDate = this.dateFromMySQLDate({ dateString: data.dateString });
		return this.prettyDateFromDate({date: jsDate});	    
	},
    formatDate: function(data) {
        var date = data.date;
        var formatString = data.formatString;
        if (!formatString) {
            return formatString;
        }
        var prefix = (data.language && data.language == "base") ? "baseLangDate" : "date";
        var forceFullDate = data.forceFullDate;
        var aYear = date.getFullYear();
        if ((aYear > Date.STANDARDMAXFULLYEAR || aYear < -Date.STANDARDMAXFULLYEAR) && data.language == "base" && !forceFullDate) {
            // If language is base, we are using the date in the admin interface
            // And if big date, just display as year
            formatString = "YYYY";
        }
    
        var firstOpenBracket = formatString.indexOf("[");
        var firstCloseBracket = formatString.indexOf("]");
        var lastChar = formatString.length-1;
    
        if (firstOpenBracket != -1 && firstCloseBracket != -1 && firstCloseBracket > firstOpenBracket) {
            var beforeText = (firstOpenBracket != 0) ? formatString.slice(0,firstOpenBracket) : "";
            var middleText = formatString.slice(firstOpenBracket+1,firstCloseBracket);
            var endText = ((firstCloseBracket+1) > firstCloseBracket) ? formatString.slice(firstCloseBracket+1) : "";
            return this.formatDate({ date: date, formatString: beforeText })+middleText+this.formatDate({ date: date, formatString: endText });
        }
    
        formatString = formatString.replace(/Summer/,"SuXXer");
        formatString = formatString.replace(/summer/,"suXXer");
        formatString = formatString.replace(/YYYY/g, AJKHelpers.formatFullYearForDate( {date: date, language: data.language }));
        formatString = formatString.replace(/MMMM/g, this[prefix+"MonthsArray"][date.getMonth()]);
        formatString = formatString.replace(/MMM/g, this[prefix+"MonthsShortArray"][date.getMonth()]);
        formatString = formatString.replace(/MM/g, this.doubleDigitNum({ num: date.getMonth()+1}));
        formatString = formatString.replace(/DD/g, this.doubleDigitNum({ num: date.getDate() }));
        formatString = formatString.replace(/dd/g, date.getDate());
        formatString = formatString.replace(/nn/g, this[prefix+"DaySuffixArray"][date.getDate()-1]);
        formatString = formatString.replace(/HH/g, this.doubleDigitNum({ num: date.getHours()}));
        formatString = formatString.replace(/mm/g, this.doubleDigitNum({ num: date.getMinutes()}));
        formatString = formatString.replace(/ss/g, this.doubleDigitNum({ num: date.getSeconds()}));
        formatString = formatString.replace(/WKD/g, this[prefix+"WeekDayArray"][date.getDay()]);
        formatString = formatString.replace(/wkd/g, this[prefix+"WeekDayShortArray"][date.getDay()]);
        formatString = formatString.replace(/SuXXer/,"Summer");
        formatString = formatString.replace(/suXXer/,"summer");
        return formatString;
    },
	formatFullYearForDate: function(data) {
		var date = data.date;
		var aYear = date.getFullYear();
		var yearString = AJKHelpers.quadrupleDigitNum({ num: aYear });
		
		if (data.language == "base") {
			// base language so an admin date	
			if (aYear < 0) {
				yearString+=" "+this.baseLangBC;
			}
		}
		else {
			if (yearString > 9999) {
				yearString = this.prettifyYearString({year: yearString });
			}
			yearString = (aYear < 0) ? ((this.dateBC) ? yearString+" "+this.dateBC : "-"+yearString) : yearString;
		}
		return yearString;
	},
	prettifyYearString: function(data) {
		var retStr = "", aYear = data.year;
		if (this.dateMillion && this.dateBillion) {
			if (aYear > 999999999) {
				retStr = aYear/1000000000;
				retStr = Math.round(retStr*100)/100; 
				retStr = retStr.toString()+" "+this.dateBillion;
			}
			else if (aYear > 999999) {
				retStr = aYear/1000000;
				retStr = Math.round(retStr*100)/100; 
				retStr = retStr.toString()+" "+this.dateMillion;
			}
			else {
				retStr = aYear;
			}
		}
		else {
			retStr = aYear;
		}
		return retStr;
	},
	prettyDateFromDate: function(data) {
		var jsDate = data.date;
		var smallDate = data.smallDate;
		var fullMonth = data.fullMonth;
		var monthStringArray = (fullMonth) ? this.dateMonthsArray : this.dateMonthsShortArray; 
	    
	    var x = jsDate.getYear();
        var y = x % 100;
        y += (y < 38) ? 2000 : 1900;
        var year = y;
		
		if (smallDate) {
			return jsDate.getDate()+"/"+(jsDate.getMonth()+1)+"/"+year.toString().substring(2,4);
		}
		else {
			return jsDate.getDate()+this.dateDaySuffixArray[jsDate.getDate()-1]+" "+monthStringArray[jsDate.getMonth()]+" "+year;
		}
	},
	prettyTimeFromDate: function(data) {
		var jsDate = data.date;
		var amOrPm = (jsDate.getHours() > 11) ? TLConfigText['basic_pm'] : TLConfigText['basic_am'];  
		var hour = jsDate.getHours() % 12;
		hour = (hour == 0) ? 12 : hour;
		var minutes = jsDate.getMinutes();
		
		return hour+":"+this.doubleDigitNum({ num: minutes })+amOrPm;	
	},
	prettyTimeFromMySQLDate: function(data) {
		var jsDate = this.dateFromMySQLDate({ dateString: data.dateString });
		return this.prettyTimeFromDate({date: jsDate});
	},
	doubleDigitNum: function(data) {
		var num = Math.abs(parseInt(data.num));
		if (num == 0) {
			return "00";
		}
		else if (num < 10) {
			return "0"+num;	
		}
		else {
			return num;	
		}
	},
	quadrupleDigitNum: function(data) {
		var num = Math.abs(parseInt(data.num));
		if (num == 0) {
			return "0000";
		}
		else if (num < 10) {
			return "000"+num;	
		}
		else if (num < 100) {
			return "00"+num;	
		}
		else if (num < 1000) {
			return "0"+num;	
		}
		else {
			return num;	
		}
	},
	deleteCookie: function(data) {
		var name = data.name;
		document.cookie = name +'=; expires=Thu, 01-Jan-70 00:00:01 GMT; path=/';
	},
	setCookie: function(data) {
	    var name = data.name;
	    var value = data.value;
	    var expires = data.expires;
	    var path = (data.path) ? data.path : "/";
	    var domain = data.domain;
	    var secure = data.secure;
	    var today = new Date();
	    today.setTime( today.getTime() );
	    if (expires) {
	        expires = expires * 1000 * 60 * 60 * 24;
	    }
	    var expires_date = new Date( today.getTime() + (expires) );
	
	    document.cookie = name + "=" +escape( value ) +
	    ( ( expires ) ? ";expires=" + expires_date.toGMTString() : "" ) +
	    ( ( path ) ? ";path=" + path : "" ) +
	    ( ( domain ) ? ";domain=" + domain : "" ) +
	    ( ( secure ) ? ";secure" : "" );
	},
	getCookie: function(data) {
		var name = data.name;
	    var start = document.cookie.indexOf( name + "=" );
	    var len = start + name.length + 1;
	    if ((!start) && (name != document.cookie.substring(0, name.length))) {
	        return null;
	    }
	    if (start == -1) { return null; }
	    var end = document.cookie.indexOf( ";", len );
	    if (end == -1) { end = document.cookie.length; }
	    return unescape(document.cookie.substring(len, end));
	},
	removeItemFromArray: function(data) { 
		var item = data.item;
		var anArray = data.anArray;
		
		var itemIndex = anArray.indexOf(item);
		
		while (itemIndex != -1) {
			anArray.splice(itemIndex,1);
			itemIndex = anArray.indexOf(item);
		}
		return anArray;
		// var returnArray = new Array();
		//for (var counter = 0; counter < anArray.length; counter++) {
		//	if (anArray[counter] != item) {
		//		returnArray.push(anArray[counter]);	
		//	}
		//}
		//return returnArray;
	},
	isItemInArray: function(data) {
		var item = data.item;
		var anArray = data.anArray;
		for (var counter = 0; counter < anArray.length; counter++) {
			if (anArray[counter] == item) {
				return true;	
			}
		}
		return false;
	},
	cloneArray: function(data) {
		var anArray = data.anArray;
		var returnArray = new Array();
		for (var counter = 0; counter < anArray.length; counter++) {
			returnArray.push(anArray[counter]);	
		}
		return returnArray;
	},
	scrollbarWidth: function() {
		// Scrollbalken im Body ausschalten
		document.body.style.overflow = 'hidden';
		var width = document.body.clientWidth;
	 
		// Scrollbalken
		document.body.style.overflow = 'scroll';
	 
		width -= document.body.clientWidth;
	 
		// Der IE im Standardmode
		if(!width) width = document.body.offsetWidth-document.body.clientWidth;
	 
		// urspr?ngliche Einstellungen
		document.body.style.overflow = '';
	 
		return width;
	},
    decode_base64: function(s) {
	    var e={},i,k,v=[],r="",w=String.fromCharCode;
	    var n=[[65,91],[97,123],[48,58],[47,48],[43,44]];
	    for(z in n){for(i=n[z][0];i<n[z][1];i++){v.push(w(i));}}
	    for(i=0;i<64;i++){e[v[i]]=i;}
	
	    for(i=0;i<s.length;i+=72){
	    var b=0,c,x,l=0,o=s.substring(i,i+72);
	         for(x=0;x<o.length;x++){
	                c=e[o.charAt(x)];b=(b<<6)+c;l+=6;
	                while(l>=8){r+=w((b>>>(l-=8))%256);}
	         }
	    }
	    return r;
    },	
    extend: function(subClass, superClass) {
		// Inheritance function courtesy Ross Harmes/Dunstan Diaz
		var F = function() {};
		F.prototype = superClass.prototype;
		subClass.prototype = new F();
		subClass.prototype.constructor = subClass;
		subClass.superClass = superClass.prototype;
		if (superClass.prototype.constructor == Object.prototype.constructor) {
			superClass.prototype.constructor = superClass;	
		}	
	},
	clipToMaxCharWords: function(data) {
		var aString = data.aString;
		var maxChars = data.maxChars;
		
		if (aString.length <= maxChars) {
			return aString;	
		}
		 
	    var wordarray = aString.split(" ");
	    var numwords=wordarray.length;
	    var newstring="";
	    var laststring="";
	    for (var counter=0; counter<numwords; counter++) {
	        laststring=newstring
	        if (counter!=0) {
	            newstring+=(" "+wordarray[counter]);
	        }
	        else {
	            newstring+=wordarray[counter];
	        }
	        if (newstring.length>maxChars) {
	            return (laststring+"...");
	        }
	    }
	    return newstring;
	},
	viewportSize: function() {
		var myWidth = 0, myHeight = 0;
		if (typeof(window.innerWidth) == 'number' ) {
			//Non-IE
			myWidth = window.innerWidth;
			myHeight = window.innerHeight;
		} 
		else if (document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)) {
			//IE 6+ in 'standards compliant mode'
			myWidth = document.documentElement.clientWidth;
			myHeight = document.documentElement.clientHeight;
		} 
		else if (document.body && (document.body.clientWidth || document.body.clientHeight)) {
			//IE 4 compatible
			myWidth = document.body.clientWidth;
			myHeight = document.body.clientHeight;
		}
		return {
	  		width: myWidth,
	  		height: myHeight	
		}
	},
	decipherQueryResult: function(data) {
		return data.queryResult;	
	},
	adjustColour: function(data) {
		var colour = data.colour;
		var adjust = data.adjust;
	    var num = parseInt(colour,16);
	    var r = parseInt((num >> 16) * adjust);
	    var b = parseInt(((num >> 8) & 0x00FF) * adjust);
	    var g = parseInt((num & 0x0000FF) * adjust);
	    r = (r < 0) ? 0 : (r > 255) ? 255 : r;
	    b = (b < 0) ? 0 : (b > 255) ? 255 : b;
	    g = (g < 0) ? 0 : (g > 255) ? 255 : g;
	    var newColor = g | (b << 8) | (r << 16);
	    newColor = newColor.toString(16);
	    for (var counter = 6-newColor.length; counter>0; counter--) {
	    	newColor="0"+newColor;
	    }
	    return newColor;
	},
	getMediaImageUri: function(data) {
		var media = data.media;
		if (media.mediaDataUri) {
			return media.mediaDataUri;
		}
		else {
			var imgSrc = (media.type == "Image") ? media.src : media.externalMediaThumb;
			return AJKHelpers.getTimelineImageUrl({ src: imgSrc });
		}
		 
	},
	getExternalAudioDataForMedia: function(data) {
		var media = data.media;
		var callback = data.callback;
		var audioSrc = media.src;
		var returnData = [];
		if (audioSrc && (audioSrc.indexOf("soundcloud.com") !== -1 || audioSrc.indexOf("snd.sc") !== -1)) {
			// http://soundcloud.com/user617448274/audio-recording-on-thursday-2?utm_source=soundcloud&utm_campaign=share&utm_medium=raw&utm_content=http://soundcloud.com/user617448274/audio-recording-on-thursday-2
			//http://snd.sc/R0YnAv
			//var cleanSrc = (audioSrc.split("?"))[0];
			returnData["externalMediaId"] = ""; 
			returnData["externalMediaType"] = "soundcloud"; 
			returnData["externalMediaThumb"] = ""; 
		}
		else {
			returnData["externalMediaId"] = "file"; 
			returnData["externalMediaType"] = "file"; 
			returnData["externalMediaThumb"] = ""; 
		}
		callback({ externalData: returnData });
	},
	getExternalVideoDataForMedia: function(data) {
		var media = data.media;
		var callback = data.callback;
		var videoSrc = media.src;
		var returnData = [];
		if (videoSrc.indexOf("vimeo.com") !== -1) {
			var vimeoId = videoSrc.split("/");	
			vimeoId = (vimeoId[vimeoId.length-1]).split("#");
			vimeoId = vimeoId[0];
			var callbackDone = false;
			
			returnData["externalMediaId"] = vimeoId; 
			returnData["externalMediaType"] = "vimeo"; 
			returnData["externalMediaThumb"] = "";
			$.getJSON("http://vimeo.com/api/v2/video/" + vimeoId + ".json?callback=?", {
				format: "json"
			}, function(jData) {
				returnData["externalMediaThumb"] = jData[0].thumbnail_large;
				if (!callbackDone) {
					callback({ externalData: returnData });
					callbackDone = true;
				}
			});
			
			setTimeout( function() {
				if (!callbackDone) {
					callback({ externalData: returnData });
					callbackDone = true;
				}
			},7000);

			/*
			$apiUrl = "http://vimeo.com/api/v2/video/".$vimeoId.".xml";
			$videoXML = DOMDocument::load($apiUrl);
			$videoThumbnail = $videoXML->getElementsByTagName("thumbnail_large")->item(0)->nodeValue; */
			// Need to use JSON to grab this. See http://stackoverflow.com/questions/1361149/get-img-thumbnails-from-vimeo
			return;
		}
		else if (videoSrc.indexOf("youtube.com") !== -1 || videoSrc.indexOf("youtu.be") !== -1) {
			if (videoSrc.indexOf("watch?v=") !== -1) {
				//http://www.youtube.com/watch?v=9a-8Zs5yXI4
				var youtubeId = videoSrc.split("watch?v=");	
				youtubeId = youtubeId[1].split("&");
				youtubeId = youtubeId[0];	
			}
			else {
				//http://www.youtube.com/kurdishblogger#p/u/19/8rrSaFvRBFU
				var youtubeId = videoSrc.split("/");	
				youtubeId = youtubeId[youtubeId.length-1];	
			}
			returnData["externalMediaId"] = youtubeId; 
			returnData["externalMediaType"] = "youtube"; 
			returnData["externalMediaThumb"] = "http://img.youtube.com/vi/"+youtubeId+"/2.jpg"; 
		}
		else {
			returnData["externalMediaId"] = "file"; 
			returnData["externalMediaType"] = "file"; 
			returnData["externalMediaThumb"] = ""; 
		}
		callback({ externalData: returnData });

		
	},
	getExternalDataForMedia: function(data) {
		var media = data.media;
		var callback = data.callback;
		if (media.type == "Video") {
			AJKHelpers.getExternalVideoDataForMedia({ 
				media: media,
				callback: callback
			});
		}
		else if (media.type == "Audio") {
			AJKHelpers.getExternalAudioDataForMedia({ 
				media: media,
				callback: callback
			});
		}
		else {
			callback({externalData: false });				
		}	
	}
}













