/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/


var AJKKeyEvent = function() {
	var self = this;
	self.observers = new Array();
	self.isInputFocussed = false;
}

AJKKeyEvent.prototype = {
	init: function() {
		var self = this;
		$(document).keyup( function(e) {
			if (e.target.tagName != "INPUT" && e.target.tagName != "TEXTAREA") {
				self.informObservers({key: e.keyCode, mode: "keyup" });
			}
		});
		return self;
	},
	informObservers: function(data) {
		var self = this;	
		$.each(self.observers, function() {
			if (this.keyEventTookPlace) {
				this.keyEventTookPlace(data);
			}	
		});
	},
	registerAsObserver: function(data) {
		var self = this;
		var observer = data.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer })
		self.observers.push(observer);
	},
	removeAsObserver: function(data) {
		var self = this;
		var observer = data.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer })
	}	
}

