/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/


var AJKMouseScrollEvent = function(data) {
	this.observers = new Array();
	this.active = false;
	this.observersOfType = new Array();
	this.preventCallback = false;
	this.disableScrollPropagation = data.disableScrollPropagation;
	return this;
}

AJKMouseScrollEvent.prototype = {
	init: function() {
		var self = this;
		$("body").mousewheel(function(event, delta) {
			self.informObserversOfScroll({delta: delta});
			if (self.disableScrollPropagation) {
				return false;
			}
		});
		
		return self;
	},
	informObserversOfScroll: function(data) {
		var self = this;
		var delta = data.delta;
		delta = (delta > 1) ? 1 : delta;
		delta = (delta < -1) ? -1 : delta;
		$.each(self.observers, function() {
			if (((this.onlyMouseScrollIfAlone && self.observers.length ==1) || !this.onlyMouseScrollIfAlone) && this.mouseDidScroll && !self.preventCallback) {
				this.mouseDidScroll({ delta: delta });	
			}
		});
	},
	registerAsObserver: function(data) {
		var self = this;
		var observer = data.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer })
		self.observers.push(observer);
		self.preventCallback = false;
	},
	removeAsObserver: function(data) {
		var self = this;
		var observer = data.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer });
		if (self.observers.length == 1) {
			this.preventCallback = true;
			setTimeout( function() {	
				// Enforce a delat after we mouseout of an area before we apply the scroll wheel effect on unique elements
				// This prevents unsightly and unexpected scrolling
				self.preventCallback = false;
			},500);
		}
	}
}
