/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

var AJKTabBlockController = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.tabMenuOptionClass = data.tabMenuOptionClass;
	self.tabSelectedClass = data.tabSelectedClass;
	self.selectedBlock = "";
	self.blocks = new Array();
}

AJKTabBlockController.prototype = {
	init: function() {
		var self = this;
		
		$(self.domRoot).find("."+self.tabMenuOptionClass).each( function() {
			var tabId = $(this).attr("tabId");
			var domBlock = $("#"+tabId).get()[0];
			var thisBlock = {
				domBlock: domBlock,
				id: tabId,
				domTab: this
			}
			self.blocks.push(thisBlock);
			
			if ($(this).hasClass(self.tabSelectedClass)) {
				self.showBlock({ block: thisBlock });			
			}
			
			$(this).click( function(e) {
				self.showBlock({ block: thisBlock });
				e.preventDefault();
			});
		});  
		
		return self;	
	},
	showBlock: function(data) {
		var self = this;	
		var block = data.block;
		
		if (block != self.selectedBlock) {
			self.hideBlock({ block: self.selectedBlock }); 			
			$(block.domBlock).css({ display: "block" });
			$(block.domTab).addClass(self.tabSelectedClass);
			self.selectedBlock = block;
		}
	},
	hideBlock: function(data) {
		var self = this;
		var block = data.block;		
		if (block) {
			$(block.domBlock).css({ display: "none" });
			$(block.domTab).removeClass(self.tabSelectedClass);
		}
	}
}

var AJKSwitchBlockController = function(data) {
	var self = this;
	self.domRoot = data.domRoot;
	self.switchClass = data.switchClass;
	self.switchSelectedClass = data.switchSelectedClass;
	self.blocks = new Array();
}

AJKSwitchBlockController.prototype = {
	init: function() {
		var self = this;
		$(self.domRoot).find("."+self.switchClass).each( function() {
			var blockId = $(this).attr("blockId");
			var domBlock = $("#"+blockId).get()[0];
			var thisBlock = {
				domBlock: domBlock,
				id: blockId,
				domSwitch: this,
				isOpen: false
			}
			self.blocks.push(thisBlock);
			
			if ($(this).hasClass(self.switchSelectedClass)) {
				self.showBlock({ block: thisBlock });			
			}
			
			$(this).click( function() {
				if (thisBlock.isOpen) {
					self.hideBlock({ block: thisBlock });
				}
				else {
					self.showBlock({ block: thisBlock });
				}
				return false;
			});
		});  
		
		return self;	
	},
	showBlock: function(data) {
		var self = this;	
		var block = data.block;
		$(block.domBlock).css({ display: "block" });
		block.isOpen = true;
		$(block.domSwitch).addClass(self.switchSelectedClass);
	},
	hideBlock: function(data) {
		var self = this;
		var block = data.block;		
		$(block.domBlock).css({ display: "none" });
		block.isOpen = false;
		$(block.domSwitch).removeClass(self.switchSelectedClass);
	}
}