/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

var AJKWindowResizeEvent = function() {
	var self = this;
	self.observers = new Array();
	self.lastWindowSize = {width: 0, height: 0 };
	self.domBody = $("body").get()[0];
	self.scrollBarsHidden = false;
	self.showScrollBarTimer = "";
}

AJKWindowResizeEvent.prototype = {
	init: function() {
		var self = this;
		var viewportSize = AJKHelpers.viewportSize();
		self.lastWindowSize.width = viewportSize.width;
		self.lastWindowSize.height = viewportSize.height;
		$(window).resize( function() {
			self.informObservers();
			self.hideScrollBars();
		});
		return self;
	},
	hideScrollBars: function() {
		var self = this;
		if (!self.scrollBarsHidden) {
			$(self.domBody).addClass("tl-overflow-hidden");
			self.scrollBarsHidden = true;	
		}
		if (self.showScrollBarTimer) {
			clearTimeout(self.showScrollBarTimer);	
		}
		self.showScrollBarTimer = setTimeout( function() {
			$(self.domBody).removeClass("tl-overflow-hidden");
			self.scrollBarsHidden = false;
		}, 200);
	},
	informObservers: function() {
		var self = this;	
		var informFunc = function() {
			var viewportSize = AJKHelpers.viewportSize();
			viewportSize.width = (viewportSize.width) ? viewportSize.width : 1; 
			viewportSize.height = (viewportSize.height) ? viewportSize.height : 1; 
			if (!(viewportSize.width == self.lastWindowSize.width && viewportSize.height == self.lastWindowSize.height)) {
				self.lastWindowSize.width = viewportSize.width;
				self.lastWindowSize.height = viewportSize.height;
				$.each(self.observers, function() {
					this.windowDidResize({ newSize: viewportSize });	
				});
			}
			
		}

		if ($.browser.msie) {
			setTimeout( function() {
				informFunc();
			},500);
		}
		else {
			informFunc();
		}
		
	},
	registerAsObserver: function(dataObj) {
		var self = this;
		var observer = dataObj.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer })
		self.observers.push(observer);
	},
	removeAsObserver: function(dataObj) {
		var self = this;
		var observer = dataObj.observer;
		self.observers = AJKHelpers.removeItemFromArray({ anArray: self.observers, item: observer })
	}	
}

