/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

var TLContentPanelController = function(data) {
	var self = this;	
	self.domRoot = data.domRoot;
	self.mainController = data.mainController;
	self.timeline = self.mainController.timeline;
	self.domContentViewport = $(self.domRoot).find(".tl-main-content-block").get()[0]; 
	self.domContentStageHolder = $(self.domRoot).find(".tl-mc-content").get()[0]; 	
	self.domContentCarousel = $(self.domRoot).find(".tl-mc-carousel").get()[0]; 	
	self.domContentCarouselStage = $(self.domContentCarousel).find(".tl-mc-carousel-stage").get()[0]; 	
	self.domTextContentBlock = $(self.domRoot).find(".tl-ch-content-block-text").get()[0];
	self.domContentIntroBlock = $(self.domRoot).find(".tl-ch-content-intro-block").get()[0]; 
	self.domPanelDateText = $(self.domRoot).find(".tl-ch-panel-date-display").get()[0]; 
	self.domHeadline = $(self.domRoot).find(".tl-ch-content-intro-block h3").get()[0]; 
	self.domStandfirst = $(self.domRoot).find(".tl-ch-content-intro-block p.tl-ch-standfirst").get()[0];
	self.domAuthorCredit = $(self.domRoot).find(".tl-ch-content-intro-block p.tl-ch-author").get()[0];
	self.domCloseButton = $(self.domRoot).find(".tl-ch-close-content").get()[0];
	self.domCloseVideoButton = $(self.domRoot).find(".tl-ch-close-video").get()[0];
	self.domNextStory = $(self.domRoot).find(".tl-ch-next-story").get()[0];
	self.domPrevStory = $(self.domRoot).find(".tl-ch-prev-story").get()[0];
	self.domStoryIndexText = $(self.domRoot).find(".tl-ch-selected-story-num").get()[0];
	self.storyIndexText = $(self.domStoryIndexText).text();
	self.domMediaSelectors = $(self.domRoot).find(".tl-ch-media-list li").get();
	self.domVideoContentHolder = $(self.domRoot).find(".tl-ch-video-content").get()[0];
	self.domVideoContent = $(self.domRoot).find(".tl-ch-vc-inner").get()[0];
	self.domGalleryBlock = $(self.domRoot).find(".tl-ch-gallery-block").get()[0];
	self.domGallery = $(self.domRoot).find(".tl-gallery").get()[0];
	self.domFullText = $(self.domRoot).find(".tl-ch-extra-info-text").get()[0];
	self.domTextContentCarousel = $(self.domRoot).find(".ajk-cs-carousel").get()[0];
	
	self.domReadMoreButton = $(self.domRoot).find(".tl-ch-full-story-link").get()[0]; 
	self.domStartTimelineButton = $(self.domRoot).find(".tl-ch-start-timeline").get()[0]; 

	self.domImageGallerySelector = self.domMediaSelectors[0];
	self.domVideoGallerySelector = self.domMediaSelectors[1];
	self.domAudioGallerySelector = self.domMediaSelectors[2];
	self.selectedGallerySelector = "";
	
	self.showVideoClass = "tl-ah-show-video-content";
	self.domGalleryBlockWidth = 380;
	self.contentViewportWidth = 0;
	self.thumbBlockHeight = 70;
	self.smallViewClass ="tl-content-holder-small-view";
	self.minHeight = 200;
	self.maxHeight = 354;
	self.galleryHideThumbHeight = 170;
	self.domGalleryMaskInner = $(self.domRoot).find(".tl-g-content-mask-inner").get()[0];
	self.imageGallery = "";
	self.bodyContent = "";
	self.standardGalleryWidth = 248;
	self.smallGalleryWidth = 200;
	self.dontDisplayGalleryWidth = 580;
	self.dontDisplayGalleryClass = "tl-content-holder-dont-display-gallery";

	self.currentGalleryWidth = self.standardGalleryWidth; 
	self.viewportWidthWhenSmallGalleryKicksIn = 600;
	self.nextStory = "";
	self.prevStory = "";
	self.panelVisible = false;
	self.selectedStory = "";
	self.maxPanelWidth = 800;
	self.panelMargin = 5;
	self.contentScroller = "";
	self.maxNextPrevChars = 40;
	self.showGallery = true;
	
	self.defaultReadMoreButtonText = TLConfigText['contentPanel_Read_more_text'];
	self.maxThumblessGalleryHeight = 233;
	self.emptyImageReplacer = "/assets/ui/default-gallery-image.gif"
}


TLContentPanelController.prototype = {
	init: function() {
		var self = this;
		
		if (self.timeline.openReadMoreLinks) {
			// We need to open read more links in new window
			$(self.domReadMoreButton).attr("target","_blank");
		}
		
		$(self.domRoot).find(".tl-mc-fade").click( function(e) {
			e.stopPropagation();
			if (self.imageViewerController && self.imageViewerController.active) {
				self.imageViewerController.hide();
			}
			else {
				self.hide();
			}
		});
		
		$(self.domStartTimelineButton).click( function() {
			self.hide();
			return false;
		});

		self.contentScroller =	new AJKContentScrollerController({
			domRootEl: self.domTextContentCarousel 
		}).init();

		self.selectedGallerySelector = self.domImageGallerySelector; 
		$(self.domMediaSelectors).each( function() {
			var thisSelector = this;
			var thisSelectorType = $(this).attr("rel"); 
			$(this).find("a").click( function() {
				var numItems = parseInt($(this).find("span").text());
				if (numItems == 0) {
					return false;
				}
				self.removeVideo();
				if (self.selectedGallerySelector != thisSelector && numItems) {
					$(self.selectedGallerySelector).removeClass("tl-ch-selected");
					self.selectedGallerySelector = thisSelector; 	
					$(self.selectedGallerySelector).addClass("tl-ch-selected");
					self.displayGalleryType({ type: thisSelectorType }); 
				}
				return false;
			});
			
		});

		$(self.domCloseButton).click( function() {
			self.hide();
			return false;
		});

		$(self.domCloseVideoButton).click( function() {
			self.removeVideo();
			return false;
		});

		$(self.domNextStory).click( function() {
			if (self.nextStory && !self.contentCarouselAnimating) {
				self.mainController.focusMarker({ marker: self.nextStory, cancelUpdateHash: true });
				//self.displayForStory({ story: self.nextStory });	
				self.animateContentToStory({ story: self.nextStory, direction: "next" });	
			}
			return false;
		});

		$(self.domPrevStory).click( function() {
			if (self.prevStory && !self.contentCarouselAnimating) {
				self.mainController.focusMarker({ marker: self.prevStory, cancelUpdateHash: true });
				//self.displayForStory({ story: self.prevStory });
				self.animateContentToStory({ story: self.prevStory, direction: "previous" });	
			}
			return false;
		});
		
		return self;		
	},
	animateContentToStory: function(data) {
		var self = this;
		if (($.browser.isIE6 || $.browser.isIE9) && self.timeline.lightboxStyle == 0) {
			self.displayForStory({ story: data.story });
			return;
		}
		self.contentCarouselAnimating = true;
		var story = data.story;
		var direction = data.direction;		
		var clonedContent = $(self.domContentStageHolder).clone(false);
		var cWidth = $(self.domContentStageHolder).width();
		var cHeight = $(self.domContentStageHolder).height()+16;
		$(self.domContentCarousel).css({ height: cHeight, overflow: "hidden" });
		var speed = 1000;
		if (direction == "next") {
			$(self.domContentStageHolder).css({ width: cWidth });
			$(clonedContent).css({ position: "absolute", left: 0, top: 0, width: cWidth });
			$(self.domContentCarouselStage).prepend(clonedContent);
			$(self.domContentStageHolder).css({ position: "absolute", left: cWidth+100, top: 0 });
			self.displayForStory({ story: story, carousel: true });
			$(self.domContentCarouselStage).animate( { left: -(cWidth+100) }, speed, function() {
				$(clonedContent).remove();
				$(self.domContentStageHolder).css({ position: "relative", left: 0, top: 0 });
				$(this).css({ left: 0});
				$(self.domContentCarousel).css({ height: "auto" });
				$(self.domContentStageHolder).css({ width: "auto" });
				self.contentCarouselAnimating = false;
			});
		}
		else {
			$(self.domContentStageHolder).css({ width: cWidth });
			$(clonedContent).css({ position: "absolute", left: cWidth+100, top: 0, width: cWidth });
			$(self.domContentCarouselStage).append(clonedContent);
			self.displayForStory({ story: story, carousel: true });
			$(self.domContentCarouselStage).css({ left: -(cWidth+100)}).animate( { left: 0 }, speed, function() {
				$(clonedContent).remove();
				$(self.domContentCarousel).css({ height: "auto" });
				$(self.domContentStageHolder).css({ width: "auto" });
				self.contentCarouselAnimating = false;
			});
		}

	},
	initialiseImageGallery: function() {
		var self = this;
		var transition = ($.browser.msie) ? "FadeIn" : "FadeIn";
		var domGalleryRoot = $(self.domRoot).find(".tl-g-main-content").get()[0]; 
		var domThumbRoot = $(self.domRoot).find(".tl-g-thumb-holder").get()[0]; 

		$(domGalleryRoot).mousedown( function(e) { 
			return false; // Stops mousedown events propogating down
		});
		
		$(domGalleryRoot).click( function(e) { 
			// We need to check if a play video button was mouseddown
			// If so, we will want to play that video
			if ($(e.target).hasClass("tl-g-video-button")) {
				var videoKey = $(e.target).attr("videoKey");
				var videoItem = self.selectedStory.mediaByKey[videoKey];
				self.loadVideo({ videoItem: videoItem });
				e.preventDefault();
				return false;
			}
			else if ($(e.target).hasClass("tl-g-audio-button")) {
				var audioKey = $(e.target).attr("audioKey");
				var audioItem = self.selectedStory.mediaByKey[audioKey];
				self.loadAudio({ audioItem: audioItem });
				e.preventDefault();
				return false;
			}
			else if ($(e.target).hasClass("tl-g-flickr-button")) {
				window.open($(e.target).attr("href"));
				e.preventDefault();
				return false;
			}
			else if ($(e.target).parent().hasClass("tl-g-caption-holder") || $(e.target).parent().parent().hasClass("tl-g-caption-holder")) {
				if ($(e.target).attr("href")) {
					window.open($(e.target).attr("href"));
				}
				return false;
			}
			else if ($(self.imageGallery.domStageHolder).hasClass("tl-g-make-item-clickable")) {
				var flickrImageUrl = AJKHelpers.getFKRPhotoPageFromImageSrc({ src: $(self.imageGallery.previousImage.domImage).attr("origSrc") });
				window.open(flickrImageUrl);
			}
			else if ($(self.selectedGallerySelector).attr("rel") == "images") {
				if (self.timeline.expander == 0) {
					return false;	
				}
				if (!self.imageViewerController) {
					self.imageViewerController	= new TLCPImageViewer({ controller: self }).init();
				}
				self.imageViewerController.launchWithImage({ 
					story: self.selectedStory, 
					imageIndex: self.imageGallery.selectedImageIndex,
					lightbox: self.timeline.lightboxStyle
				});
			}	
		});
		
		$(domThumbRoot).mousedown( function(e) { // Stops mousedown events propogating down
			return false;
		});
		
		self.imageGallery = new AJKImageGallery({
			domRootEl: domGalleryRoot,
			domStageHolder: $(self.domRoot).find(".tl-g-main-content").get()[0],
			domStage: $(self.domRoot).find(".tl-g-main-stage").get()[0],
			transition: transition,
			domPrevButton: $(self.domRoot).find(".tl-g-gallery-control-left").get()[0],
			domNextButton: $(self.domRoot).find(".tl-g-gallery-control-right").get()[0],
			buttonHideClass: "tl-hide",
			imageInfoFunction: "",
			imageHolderHTML:'<div class="tl-g-main-item ak-image-holder"></div>',
			thumbBlockSize: {
				height: 60,
				width: 60,
				widthPadding: 3
			},
			createImageInfoHTML: function(data) {
				var anImage = data.image;
				var insertHTML = "";
				if (anImage.caption) {
					insertHTML += '<div class="tl-g-caption-holder">';
					insertHTML += '<p>'+anImage.caption+'</p>';
					insertHTML += '</div>';
				}
				if (anImage.type == "Video") {
					insertHTML += '<a href="#" class="tl-g-media-button tl-g-video-button" videoKey="'+anImage.key+'">'+TLConfigText['contentPanel_Play_video']+'</a>';
				}
				if (anImage.type == "Audio") {
					insertHTML += '<a href="#" class="tl-g-media-button tl-g-audio-button" audioKey="'+anImage.key+'">'+TLConfigText['contentPanel_Play_audio']+'</a>';
				}
				if (anImage.type == "Image" && AJKHelpers.isFlickrImage({ src: anImage.src }) && 0) {
					var fkrLink = AJKHelpers.getFKRPhotoPageFromImageSrc({ src: anImage.src });
					insertHTML += '<a href="'+fkrLink+'" class="tl-g-media-button tl-g-flickr-button" imageKey="'+anImage.key+'">View on Flickr</a>';
				}
				return insertHTML;
			},
			createDomImage: function(data) {
				var anImage = data.image;
				var insertHTML = "";
				if (anImage.type == "Image") {
					var imageSrc = anImage.mediaDataUri || AJKHelpers.getTimelineImageUrl({ src: anImage.src, emptyImage: self.emptyImageReplacer });
					insertHTML += '<img origSrc="'+anImage.src+'" src="'+imageSrc+'" alt="'+anImage.caption+'" />';
				}
				else if (anImage.type == "Video") {
					var imageSrc = anImage.mediaDataUri || AJKHelpers.getTimelineImageUrl({ src: anImage.externalMediaThumb, emptyImage: self.mainController.defaultVideoImage });
					insertHTML += '<img src="'+imageSrc+'" alt="'+anImage.caption+'" />';
				}
				else if (anImage.type == "Audio") {
					var audioImage = anImage.mediaDataUri || AJKHelpers.getTimelineImageUrl({ src: anImage.externalMediaThumb, emptyImage: self.mainController.defaultAudioImage });
					insertHTML += '<img src="'+audioImage+'" alt="'+anImage.caption+'" />';
				}
				return $(insertHTML).get()[0];
			},
			domThumbPrevButton: $(self.domRoot).find(".tl-g-thumb-control-left").get()[0],
			domThumbNextButton: $(self.domRoot).find(".tl-g-thumb-control-right").get()[0],
			selectedThumbClass: "tl-g-thumb-item-selected",
			domThumbsHolder: domThumbRoot,
			domThumbsStage: $(self.domRoot).find(".tl-g-thumb-stage").get()[0],
			createThumbBlockFunc: function(data) {
				var domImage = data.domImage;
				var insertHTML = '<div class="tl-g-thumb-item">';
				insertHTML += '<div class="tl-g-thumb-mask"></div>';
				insertHTML += '</div>';
				var domThumb = $(insertHTML).get()[0];
				$(domThumb).prepend(domImage);
				return domThumb;
			},
			resizeCallbackFunc: function(data) {
				var newSize = data.newSize;
				$(self.domGalleryMaskInner).css({ height: newSize.height-2 });
			},
			imageWasSelected: function(data) {
				var origSrc = $(data.anImage.domImage).attr("origSrc");
				var domGStage = self.imageGallery.domStageHolder;
				if (origSrc && origSrc.indexOf("flickr.com") != -1 && 0) {
					$(domGStage).addClass("tl-g-make-item-clickable");
				}
				else {
					$(domGStage).removeClass("tl-g-make-item-clickable");
				}
				if ($(self.selectedGallerySelector).attr("rel") == "images" && self.timeline.expander != 0) {
					$(domGStage).addClass("tl-g-mc-image-hover");
				}
				else {
					$(domGStage).removeClass("tl-g-mc-image-hover");
				}
			}
		}).init();
	},
	loadVideo: function(data) {
		var self = this;
		var videoItem = data.videoItem;
		var embedHTML = AJKHelpers.generateVideoEmbedHTML({
			src: videoItem.src,
			type: videoItem.externalMediaType,
			videoId: videoItem.externalMediaId,
			width: "100%",
			height: "100%",
			colour: self.timeline.mainColour,
			autoplay: true,
			theme: (self.timeline.lightboxStyle == 1) ? "light" : "dark"
		});
		$(self.domCloseVideoButton).text(TLConfigText['contentPanel_Close_video']);
		$(self.domVideoContentHolder).css({ display: "block" });
		$(self.domContentViewport).addClass(self.showVideoClass);		
		$(self.domVideoContent).html(embedHTML);		
	},
	loadAudio: function(data) {
		var self = this;
		var audioItem = data.audioItem;
		var embedHTML = AJKHelpers.generateAudioEmbedHTML({
			src: audioItem.src,
			type: audioItem.externalMediaType,
			audioId: audioItem.externalMediaId,
			width: "100%",
			height: "100%",
			colour: self.timeline.mainColour,
			autoplay: true
		});
		$(self.domCloseVideoButton).text(TLConfigText['contentPanel_Close_audio']);
		$(self.domVideoContentHolder).css({ display: "block" });
		$(self.domContentViewport).addClass(self.showVideoClass);		
		$(self.domVideoContent).html(embedHTML);		
	},
	displayGalleryType: function(data) {
		var self = this;
		var galleryType = data.type;
		self.imageGallery.loadWithImages({images: self.selectedStory[galleryType] });
		self.resizeContent({ newSize: AJKHelpers.viewportSize() });
	},
	updateMediaGallerySelectors: function(data) {
		var self = this;
		var story = data.story;
		$(self.domImageGallerySelector).removeClass("tl-ch-disabled").find("span").text(story.images.length);
		$(self.domVideoGallerySelector).removeClass("tl-ch-disabled").find("span").text(story.videos.length);	
		$(self.domAudioGallerySelector).removeClass("tl-ch-disabled").find("span").text(story.audio.length);
		if (story.images.length == 0) {
			$(self.domImageGallerySelector).addClass("tl-ch-disabled");
		}
		if (story.videos.length == 0) {
			$(self.domVideoGallerySelector).addClass("tl-ch-disabled");
		}
		if (story.audio.length == 0) {
			$(self.domAudioGallerySelector).addClass("tl-ch-disabled");
		}
		
		$(self.selectedGallerySelector).removeClass("tl-ch-selected");
		if (story.videos.length > 0) {
			self.selectedGallerySelector = self.domVideoGallerySelector;
		}
		else if (story.audio.length > 0 && story.images.length == 0) {
			self.selectedGallerySelector = self.domAudioGallerySelector;
		}
		else {
			self.selectedGallerySelector = self.domImageGallerySelector;
		}
		$(self.selectedGallerySelector).addClass("tl-ch-selected");

	},
	displayForStory: function(data) {
		var self = this;
		var story = data.story;
		self.showGallery = true;
		var borderColor = (story.isTimelineIntro) ? "#"+self.timeline.mainColour : "#"+story.category.colour;
		borderColor = (self.timeline.lightboxStyle == 1) ? borderColor : "transparent";
		if (data.carousel && self.timeline.lightboxStyle == 1) {
			$(self.domContentViewport).animate({ backgroundColor: borderColor },700);
		}
		else {
			$(self.domContentViewport).css({ backgroundColor: borderColor });
		}

		//var cancelGalleryTransition = !self.panelVisible || data.cancelGalleryTransition;
		var cancelGalleryTransition = true;

		self.selectedStory = story;
		
		if (!self.panelVisible) {
			$(self.domRoot).css({ display: "block", visibility:"hidden" });
			setTimeout( function() {
				self.fadeInPanel();	
			},1);
		}
				
		if (!story.isTimelineIntro && !story.extraInfoLoaded) {
			// The story's extrainfo has not loaded, so hide content until it appears
			$(self.domContentStageHolder).css({ visibility: "hidden" });
			(function() {
				var thisFunc = arguments.callee;
				if (story.extraInfoLoaded) {
					self.bodyContent = (story.fullText) ? self.formatBodyText({ text: story.fullText }) : "";
					$(self.domFullText).html(self.bodyContent);
					self.contentScroller.reset();
					self.contentScroller.resetSize();
					$(self.domContentStageHolder).css({ visibility: "visible" });
					self.resizeContent({ newSize: AJKHelpers.viewportSize() });
					
				}
				else {
					setTimeout(function() {
						thisFunc();
					},10);	
				}
			})(); 
		}


		if (story.isTimelineIntro) {
			// If displaying the intro to the timeline, we don't want to show
			$(self.domContentViewport).addClass("tl-ch-timeline-intro-view");	
			//$(self.domPanelDateText).text(TLConfigText['basic_By']+" "+self.timeline.authorName);	
			$(self.domPanelDateText).text(" ");	
		}
		else {
			$(self.domContentViewport).removeClass("tl-ch-timeline-intro-view");
			if (story.dateStatus == 1) {
				$(self.domPanelDateText).text("n/a").removeClass("tl-hide").addClass("tl-hide");
			}
			else if (story.dateStatus == 2) {
				$(self.domPanelDateText).text("~"+story.formatDisplayDate()).removeClass("tl-hide");
			}
			else {
				$(self.domPanelDateText).text(story.formatDisplayDate()).removeClass("tl-hide");
			}
		}

		if (story.externalLink) {
			var buttonText = self.defaultReadMoreButtonText;
			if (story.feedSource == "twitter") {
				buttonText = TLConfigText['contentPanel_View_on']+" Twitter"
			}
			else if (story.feedSource == "youtube") {
				buttonText = TLConfigText['contentPanel_View_on']+" YouTube"
			}
			$(self.domReadMoreButton).text(buttonText).css({ display: "block" }).attr("href",story.externalLink);	
		}
		else {
			$(self.domReadMoreButton).css({ display: "none" });
		}

		self.removeVideo();

		self.panelVisible = true;
		
		self.prevStory = self.mainController.getPrevStory({story:story}); 
		if (self.prevStory) {
			$(self.domPrevStory).text(AJKHelpers.clipToMaxCharWords({ aString: self.prevStory.headline, maxChars: 40 })).css({ display:"block"});
			self.prevStory.loadExtraInfo();
		}
		else {
			$(self.domPrevStory).css({ display:"none"});
		}
				
		self.nextStory = self.mainController.getNextStory({story:story}); 
		if (self.nextStory) {
			$(self.domNextStory).text(AJKHelpers.clipToMaxCharWords({ aString: self.nextStory.headline, maxChars: 40 }) ).css({ display:"block"});
			self.nextStory.loadExtraInfo();
			self.lastStoryReached = false;
		}
		else {
			$(self.domNextStory).css({ display:"none"});
			self.lastStoryReached = true;
		}
		var numStories = self.mainController.getNumStories();
		

		var storyIndexText = self.storyIndexText.replace("x1",(story.orderIndex+1)).replace("x2",numStories);
		$(self.domStoryIndexText).text(storyIndexText);


		self.bodyContent = (story.fullText) ? self.formatBodyText({ text: story.fullText }) : "";
		
		$(self.domFullText).html(self.bodyContent);
		
		$(self.domHeadline).text(story.headline); //.css({ color: "#"+story.category.colour })
		$(self.domStandfirst).empty().append(story.clippedContentIntroText);
		if (story.ownerName) {
			$(self.domAuthorCredit).text(TLConfigText['basic_By']+" "+story.ownerName).css({ display: "block" });
		}
		else {
			$(self.domAuthorCredit).css({ display: "None" });
		}
		$(self.domRoot).css({ display: "block" });
		if (!self.imageGallery) {
			self.initialiseImageGallery();	
		}
		
		var galleryImages = ""; 
		
		self.updateMediaGallerySelectors({ story: story });

		if (story.images.length > 0 && story.feedSource != "twitter") {
			galleryImages = story.images;
		}
		/*else if (self.timeline.introImage) {
			galleryImages = [{ id: "noId", src: self.timeline.introImage, caption: self.timeline.introImageCredit, type: "Image" }];
		}
		else if (self.timelineBackgroundImage) {
			galleryImages = [{ id: "noId", src: self.timelineBackgroundImage, caption: self.timeline.backgroundImageCredit, type: "Image" }];
		} */
		else {
			galleryImages = [{ id: "noId", src: "", caption: "", type: "Image" }];
		}
		
		if (story.videos.length > 0) {
			self.imageGallery.loadWithImages({images: story.videos, clearTransition: cancelGalleryTransition });
		}
		else if (story.audio.length > 0 && story.images.length == 0) {
			self.imageGallery.loadWithImages({images: story.audio, clearTransition: cancelGalleryTransition });
		}
		else {		
			self.imageGallery.loadWithImages({images: galleryImages, clearTransition: cancelGalleryTransition });
		}
			
		if (story.videos.length == 0 && story.audio.length==0 && !galleryImages[0].src) {
			self.showGallery = false;
		}
		
		theAJKWindowResizeEvent.removeAsObserver({ observer: self });
		theAJKWindowResizeEvent.registerAsObserver({ observer: self });
		
		self.resizeContent({ newSize: AJKHelpers.viewportSize() });
		setTimeout( function() {
			self.resizeContent({ newSize: AJKHelpers.viewportSize() });
		});

		self.contentScroller.reset();
		self.contentScroller.resetSize();
		
		if (!story.isTimelineIntro) {
			theTLHashController.setHashToStoryPanel({
				storyId: story.id
			});	
		}


	},
	removeVideo: function() {
		var self = this;
		$(self.domVideoContent).empty();
		setTimeout( function() {	
			$(self.domVideoContentHolder).css({ display: "none" });
			$(self.domContentViewport).removeClass(self.showVideoClass);		
		},1);
	},
	hide: function() {
		var self = this;
		
		theAJKWindowResizeEvent.removeAsObserver({ observer: self });
		if ($.browser.msie && $.browser.version < 9) {
			$(self.domRoot).css({ display: "none" });
			self.removeVideo();
		}
		else {
			$(self.domRoot).animate({ opacity: 0},500, function() {
				$(this).css({ display: "none" });
				self.removeVideo();
			});	
		}
		self.panelVisible = false;
		theTLHashController.setHashToCurrentDate();
        
	},
	fadeInPanel: function() {
		var self = this;
		
		if ($.browser.msie) {
			$(self.domRoot).css({ display: "block", visibility:"hidden" });
			setTimeout( function() {
				$(self.domRoot).css({ visibility:"visible" });
				$(self.domContentViewport).css({ visibility: "visible" });
			},1);
		}
		else {
			$(self.domRoot).css({ opacity: 0, display:"block", visibility: "visible" });
			setTimeout( function() {
				$(self.domContentViewport).css({ visibility: "visible", opacity: "1" });
				$(self.domRoot).animate({ opacity: 1},500);	
			},1);			
		}		
		self.panelVisible = true;
	},
	windowDidResize: function(data) {
		var self = this;
		var newSize = data.newSize;
		self.resizeContent({ newSize: newSize });
	},
	resizeContent: function(data) {
		var self = this;
		var newSize = data.newSize;
		
		var showGallery = (newSize.width < self.dontDisplayGalleryWidth) ? false : self.showGallery ;
		
		if (showGallery) {
			$(self.domContentStageHolder).removeClass(self.dontDisplayGalleryClass);	
		}
		else {
			$(self.domContentStageHolder).addClass(self.dontDisplayGalleryClass);	
		}
		
		var gallerySize = "standard";
		
		/*$(self.domContentStageHolder).removeClass("tl-ch-content-smaller-text");
		$(self.domContentStageHolder).removeClass("tl-ch-content-small-text-large-standfirst");
		$(self.domContentStageHolder).removeClass("tl-ch-content-large-standfirst");*/
		
		var smallTextLayout = false;
		var contentHeight = newSize.height - 150;
		
		contentHeight = (contentHeight > self.minHeight) ? contentHeight : self.minHeight;
		contentHeight = (contentHeight < self.maxHeight) ? contentHeight : self.maxHeight;
		
		$(self.domContentStageHolder).css({ height: contentHeight});
		
		$(self.domTextContentCarousel).css({ height: contentHeight-48});
		
		$(self.domGallery).css({ height: contentHeight-48});

		var panelWidth = newSize.width-50;
		panelWidth = (panelWidth > self.maxPanelWidth) ? self.maxPanelWidth : panelWidth;
		
		self.panelMargin = (newSize.height-contentHeight-84)/2;

		$(self.domContentViewport).css({ top: self.panelMargin, width: panelWidth });
		
		$(self.domVideoContentHolder).css({ height: contentHeight-48, width: panelWidth-40});
		
		self.contentViewportWidth = $(self.domContentStageHolder).width();

		if (!showGallery) {
			self.currentGalleryWidth = 0;
		}
		else if (self.contentViewportWidth <= self.viewportWidthWhenSmallGalleryKicksIn) {
			self.currentGalleryWidth = self.smallGalleryWidth;
			gallerySize = "smaller";
			//$(self.domContentStageHolder).addClass("tl-ch-content-smaller-text");
			smallTextLayout = true;
		}
		else {
			self.currentGalleryWidth = self.standardGalleryWidth;
		}
		
		// Ensure the datetext author name aligns with the text
		var dateTextLeft = self.currentGalleryWidth + ((showGallery) ? 20 : 0);
		$(self.domPanelDateText).css({ left: dateTextLeft });
		
		// Limit the number of chars displayed for next previous story
		var nextPrevChars = parseInt((self.contentViewportWidth -100)/17);
		nextPrevChars = (nextPrevChars > self.maxNextPrevChars) ? self.maxNextPrevChars : nextPrevChars;
		if (self.prevStory) {
			$(self.domPrevStory).text(AJKHelpers.clipToMaxCharWords({ aString: self.prevStory.headline, maxChars: nextPrevChars }));
		}
		if (self.nextStory) {
			$(self.domNextStory).text(AJKHelpers.clipToMaxCharWords({ aString: self.nextStory.headline, maxChars: nextPrevChars }) );
		}

		if (contentHeight - self.minHeight < 30) {
			gallerySize = "smaller";
			//$(self.domContentStageHolder).addClass("tl-ch-content-smaller-text");
			smallTextLayout = true;
		}

		if (!self.selectedStory.fullText) {
			var extraClass = (smallTextLayout) ? "tl-ch-content-small-text-large-standfirst" : "tl-ch-content-large-standfirst";	
			//$(self.domContentStageHolder).addClass(extraClass);
		}
		
		$(self.domTextContentBlock).css({ width: self.contentViewportWidth - self.currentGalleryWidth - 1 });

		if (self.imageGallery && showGallery) {
			
			var setUpGallery = function() {
				var galleryHeight = contentHeight - 51 - self.thumbBlockHeight;
				var forceHideThumbs = false;
				
				/*if (self.selectedStory.videos.length == 0 && self.selectedStory.images.length <= 1) {
					forceHideThumbs = true;
				}*/
				
				if (self.selectedStory.isTimelineIntro || self.imageGallery.numImages <= 1) {
					forceHideThumbs = true;
				}
				
				if (galleryHeight < self.galleryHideThumbHeight || self.currentGalleryWidth < self.standardGalleryWidth || forceHideThumbs) {
					galleryHeight += self.thumbBlockHeight;
					self.imageGallery.hideThumbs();
					
					// Check if the image will not work as portrait
					if ((self.selectedStory.mainImageWidth > 0 && self.selectedStory.mainImageHeight/self.selectedStory.mainImageWidth < 1.2) || !self.selectedStory.mainImageHeight) {
						galleryHeight = (galleryHeight > self.maxThumblessGalleryHeight) ? self.maxThumblessGalleryHeight : galleryHeight;
					}
					
					if (!self.selectedStory.mainImageHeight) {
						// Image has not loaded at this stage, so we need to wait until it is loaded
						(function() {
							var thisFunc = arguments.callee;
							if (self.selectedStory.mainImageHeight) {
								self.resizeContent({ newSize: AJKHelpers.viewportSize() });	
							}
							else {
								setTimeout( function() {
									thisFunc();
								},100);	
							}
						})();
					}
				}
				else {
					self.imageGallery.showThumbs();
				}
				
				$(self.domGalleryBlock).css({ width: self.currentGalleryWidth });
				
				self.imageGallery.updateSizeTo({
					size: {
						width: self.currentGalleryWidth,
						height: galleryHeight
					}
				});
			}
			
			
			if ($.browser.msie) {
				setTimeout( function() {
					setUpGallery();
				},1);
				
			}
			else {
				setUpGallery();
			}
		}

		self.contentScroller.resetSize();

	},
	formatBodyText: function(data) {
		var self = this;
		var someText = data.text;
		var extraLinkText = (self.timeline.embed == "true") ? 'target="_top"' : "";
		extraLinkText = (self.timeline.openReadMoreLinks == 1) ? 'target="_blank"' : extraLinkText;
		
		if (someText) {
			someText = someText.replace(/\\'/g,"'").replace(/;xNLx;/g,"\n").replace(/\r\n/g,"\n").replace(/\r/g,"\n").replace(/\n\n/g,"\n").replace(/   /g," ").replace(/  /g," ").replace(/ \n/g,"\n").replace(/\n/g,"</p><p>");
			someText = '<p>'+someText+'</p>';
			
			var aMatch = "";
			while ((aMatch = someText.match(/\[([^-\[\(\]\)]*)\]\(([^\[\(\]\)]*)\)/))) {
				var aLink = AJKHelpers.customCreateClickableLinks({ aString: aMatch[0], extra: extraLinkText });
				someText = someText.replace(aMatch[0],aLink);
			}

		}
		return someText;
	}
}

var TLCPImageViewer = function(data) {
	var self = this;
	self.controller = data.controller;
	self.timeline = self.controller.timeline;
	self.imageGallery = self.controller.imageGallery;
	self.domRoot = $("#tl-cp-image-viewer").get()[0];
	self.domClose = $(self.domRoot).find(".tl-cpiv-content-mask a").get()[0];
	self.domMask = $(self.domRoot).find(".tl-cpiv-content-mask-inner").get()[0];
	self.domCaption = $(self.domRoot).find(".tl-cpiv-caption-holder").get()[0];
	self.domImageHolder = $(self.domRoot).find(".tl-cpiv-main-item").get()[0];
	self.screenSize = {};
	self.active = false;
	self.animating = false;
}

TLCPImageViewer.prototype = {
	init: function() {
		var self = this;
		$(self.domClose).click( function() {
			self.hide();
			return false;	
		});
		
		return self;
	},
	launchWithImage: function(data) {
		var self = this;	
		if (self.active) {
			return;	
		}
		
		$(self.domRoot).removeClass("tl-cp-lightbox-2");
		if (data.lightbox == 1) {
			$(self.domRoot).addClass("tl-cp-lightbox-2");
		}
		
		self.screenSize = AJKHelpers.viewportSize();
		var story = data.story;
		var startSize = self.imageGallery.gallerySize;
		var startPos = AJKHelpers.getCoordsOfDomEl({ domEl: self.imageGallery.domStageHolder });
		var galleryImage = self.galleryImage = self.imageGallery.images[data.imageIndex];
		var objImage = self.controller.selectedStory.images[data.imageIndex];

		var imageSize = {
			width:  galleryImage.domImage.naturalWidth || galleryImage.size.width,
			height:  galleryImage.domImage.naturalHeight || galleryImage.size.height	
		};
		if (!imageSize.height) {
			return; // image not loaded	
		} 
		theAJKWindowResizeEvent.removeAsObserver({ observer: self.controller });
		self.naturalImageSize = {
			width: imageSize.width,
			height: imageSize.height
		}
		self.domImage = $(self.imageGallery.images[data.imageIndex].domImage).clone();
		
		self.active = true;
		self.animating = true;
		var endSize = self.adjustImageSize({ imageSize: imageSize });
		var newLeft = Math.round((self.screenSize.width-endSize.width)/2);
		var newTop = Math.round((self.screenSize.height-endSize.height)/2);
		$(self.domImageHolder).empty().append(self.domImage);
		if (objImage.caption) {
			$(self.domCaption).css({ display: "block" }).find("p").empty().append(objImage.caption);
			$(self.domCaption).find("a").click( function() {
				window.open($(this).attr("href"));
				return false;
			});
		}
		else {
			$(self.domCaption).css({ display: "none" });
		}
		if ($.browser.msie || self.timeline.expander != 2) {
			$(self.controller.domContentViewport).css({ display: "none" });
			$(self.domImage).css({ height: endSize.height, width: endSize.width, top: 0, left: 0 });
			$(self.domRoot).css({ width: endSize.width, height: endSize.height, left: newLeft, top: newTop, display: "block" });
			$(self.domMask).css({ height: endSize.height-2 });
			self.animating = false;
			theAJKWindowResizeEvent.registerAsObserver({ observer: self });
		}
		else {
			setTimeout( function() {
				$(self.domMask).css({ height: startSize.height-2 });
				$(self.domRoot).css({ width: startSize.width, height: startSize.height, left: startPos.x, top: startPos.y, display: "block", opacity: 0 });
				$(self.domRoot).animate( { opacity: 1 }, 500)
				$(self.controller.domContentViewport).animate({ opacity: 0 }, 500, function() {
					$(this).css({ display: "none" });
					$(self.domImage).animate({ height: endSize.height, width: endSize.width, top: 0, left: 0 },750);
					$(self.domRoot).animate({ width: endSize.width, height: endSize.height, left: newLeft, top: newTop }, 750, function() {
						self.animating = false;
						theAJKWindowResizeEvent.registerAsObserver({ observer: self });
					});
					$(self.domMask).animate({ height: endSize.height-2 },750);
					//$(self.controller.domRoot).find(".tl-mc-fade").animate({ opacity: 0.85 }, 750);
				});
			},10);
		}
	},
	adjustImageSize: function(data) {
		var self = this;
		var minSize = 320;
		var imageSize = data.imageSize;
		var retSize = {};
		if (imageSize.width >= imageSize.height && imageSize.height < minSize) {
			retSize.height = minSize;	
			retSize.width = Math.round(imageSize.width * minSize/imageSize.height);
		}
		else if (imageSize.height > imageSize.width && imageSize.width < minSize) {
			retSize.width = minSize;	
			retSize.height = Math.round(imageSize.height * minSize/imageSize.width);
		}
		else {
			retSize = imageSize; 	
		}
		return self.restrictImageSizeToScreen({ imageSize: retSize });
	},
	restrictImageSizeToScreen: function(data) {
		var self = this;
		var padding = 40;
		var imageSize = data.imageSize;
		var screenSize = data.screenSize || AJKHelpers.viewportSize();
		
		var maxWidth = screenSize.width - padding;
		var maxHeight = screenSize.height - padding;
		var retSize = {
			width: imageSize.width,
			height: imageSize.height
		}
		if (imageSize.width > maxWidth) {
			retSize.width = maxWidth;
			retSize.height = imageSize.height * maxWidth/imageSize.width;
			imageSize = {
				width: retSize.width,
				height: retSize.height
			}
		}
		if (imageSize.height > maxHeight) {
			retSize.height = maxHeight;
			retSize.width = imageSize.width * maxHeight/imageSize.height;
		}
		return retSize;
	},
	windowDidResize: function(data) {
		var self = this;
		var newSize = data.newSize;
		var imageSize = self.adjustImageSize({ imageSize: self.naturalImageSize });
		var newLeft = Math.round((newSize.width-imageSize.width)/2);
		var newTop = Math.round((newSize.height-imageSize.height)/2);
		$(self.domRoot).css({ width: imageSize.width, height: imageSize.height, left: newLeft, top: newTop });
		$(self.domImage).css({ height: imageSize.height, width: imageSize.width });
		$(self.domMask).css({ height: imageSize.height-2 });
	},
	hide: function(data) {
		var self = this;
		
		if (!self.active || self.animating) {
			return;	
		}

		theAJKWindowResizeEvent.removeAsObserver({ observer: self });
		theAJKWindowResizeEvent.registerAsObserver({ observer: self.controller });
		$(self.controller.domContentViewport).css({ visibility: "hidden", display: "block" });
		self.controller.windowDidResize({ newSize: AJKHelpers.viewportSize() });

		if ($.browser.msie || self.timeline.expander != 2) {
			$(self.domRoot).css({ display: "none" });	
			$(self.controller.domContentViewport).css({ visibility: "visible" });
			if (!$.browser.msie) {
				$(self.controller.domContentViewport).css({ opacity: 1 });
			}
			self.animating = false;
			self.active = false;
		}
		else {
			self.animating = true;
			var domGImage =  self.galleryImage.domImage;
			var origSize = {
				width: $(domGImage).width(),
				height: 	$(domGImage).height(),
				top: parseInt($(domGImage).css("top")),
				left: parseInt($(domGImage).css("left"))
			}
			var endSize = self.imageGallery.gallerySize;

			//$(self.controller.domRoot).find(".tl-mc-fade").animate({ opacity: 0.75 }, 750);
			var endPos = AJKHelpers.getCoordsOfDomEl({ domEl: self.imageGallery.domStageHolder });
			$(self.domImage).animate({ height: origSize.height, width: origSize.width, top: origSize.top, left: origSize.left },750);
			$(self.domMask).animate({ height: endSize.height-2 },750);
			$(self.domRoot).animate({ width: endSize.width, height: endSize.height, left: endPos.x, top: endPos.y }, 750, function() {
				$(self.controller.domContentViewport).css({ visibility: "visible" }).animate({ opacity: 1 }, 500, function() {
					$(self.domRoot).css({ display: "none" });
					self.animating = false;
					self.active = false;
				});
				$(self.domRoot).animate({ opacity: 0 }, 800)
			});
		}
		
	}
}