/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/


TLViewController.viewScaleSettings = new Array();


/*
hour-5-mins-medium 374588.77866666665
hour-10-mins-medium 187294.38933333333
day-medium-hour 31215.731555555554
month-small-day 1300.6554814814815
month-tiny-day 426.7775798611111
year-medium-month 42.73288507711391
year-small-month 21.366442538556957
year-tiny-month 14.021727915928
*/


TLViewController.viewScaleSettings["hour-5-mins-medium"] = {
	getStageWidthRatio: function() {
		return 768/AJKHelpers.dateOneHourInMS; // 768 = the width of one hour in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time: aDate.getTime() });
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		retDate.setMilliseconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time:blockStartDate.getTime()+AJKHelpers.dateOneHourInMS });
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		retDate.setMilliseconds(0);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		var minutes = aDate.getMinutes();
		var hour = aDate.getHours();

		var lang = theTLMainController.timeline.language;
		
		var mornAft = TLConfigText['basic_am'];

		if (lang && lang != "english") {
			mornAft = "";			
		}
		else {
			if (hour > 12) {
				hour -=12;
				mornAft = TLConfigText['basic_pm'];
			}
			else if (hour == 12 && minutes > 0) {
				mornAft = TLConfigText['basic_pm'];
			}
		}
		
		if (this.roundMinutes) {
			minutes =  parseInt((minutes +this.roundMinutes/5)/this.roundMinutes) * this.roundMinutes;
		}
		if (minutes == 0 && hour == 12 && !(lang && lang != "english")) {
			return TLConfigText['basic_Noon'] ;	
		}
		else if (minutes == 0 && hour == 0) {
			return aDate.getDate()+" "+AJKHelpers.dateMonthsShortArray[aDate.getMonth()];
		}
		else {
			return hour+":"+AJKHelpers.doubleDigitNum({num: minutes })+mornAft;
		}
	},
	displayDateFormat: "ddnn MMMM YYYY HH:mm",
	numItems: 12,
	segmentWidth: 64,
	roundMinutes:5
}

TLViewController.viewScaleSettings["hour-10-mins-medium"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-10-mins-medium"].getStageWidthRatio = function() {
	return 384/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-10-mins-medium"].numItems = 6;
TLViewController.viewScaleSettings["hour-10-mins-medium"].segmentWidth = 64;
TLViewController.viewScaleSettings["hour-10-mins-medium"].roundMinutes = 10;

TLViewController.viewScaleSettings["hour-15-mins-medium"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-15-mins-medium"].getStageWidthRatio = function() {
	return 256/AJKHelpers.dateOneHourInMS; // 256 = the width of one hour in this mode	
}
TLViewController.viewScaleSettings["hour-15-mins-medium"].numItems = 4;
TLViewController.viewScaleSettings["hour-15-mins-medium"].segmentWidth = 64;
TLViewController.viewScaleSettings["hour-15-mins-medium"].roundMinutes = 5;

TLViewController.viewScaleSettings["hour-5-mins-large"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-5-mins-large"].getStageWidthRatio = function() {
	return 1536/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-5-mins-large"].numItems = 12;
TLViewController.viewScaleSettings["hour-5-mins-large"].segmentWidth = 128;
TLViewController.viewScaleSettings["hour-5-mins-large"].roundMinutes = 5;

TLViewController.viewScaleSettings["hour-5-mins-very-large"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-5-mins-very-large"].getStageWidthRatio = function() {
	return 3072/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-5-mins-very-large"].numItems = 12;
TLViewController.viewScaleSettings["hour-5-mins-very-large"].segmentWidth = 256;
TLViewController.viewScaleSettings["hour-5-mins-very-large"].roundMinutes = 5;

TLViewController.viewScaleSettings["hour-1-mins-small"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-1-mins-small"].getStageWidthRatio = function() {
	return 3840/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-1-mins-small"].numItems = 60;
TLViewController.viewScaleSettings["hour-1-mins-small"].segmentWidth = 64;
TLViewController.viewScaleSettings["hour-1-mins-small"].roundMinutes = 1;

TLViewController.viewScaleSettings["hour-1-mins-medium"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-1-mins-medium"].getStageWidthRatio = function() {
	return 7680/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-1-mins-medium"].numItems = 60;
TLViewController.viewScaleSettings["hour-1-mins-medium"].segmentWidth = 128;
TLViewController.viewScaleSettings["hour-1-mins-medium"].roundMinutes = 1;

TLViewController.viewScaleSettings["hour-1-mins-large"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-1-mins-large"].getStageWidthRatio = function() {
	return 15360/AJKHelpers.dateOneHourInMS; 	
}
TLViewController.viewScaleSettings["hour-1-mins-large"].numItems = 60;
TLViewController.viewScaleSettings["hour-1-mins-large"].segmentWidth = 256;
TLViewController.viewScaleSettings["hour-1-mins-large"].roundMinutes = 1;


/* TLViewController.viewScaleSettings["hour-1-mins-medium"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["hour-5-mins-medium"] }); 
TLViewController.viewScaleSettings["hour-1-mins-medium"].getStageWidthRatio = function() {
	return 384/AJKHelpers.dateOneHourInMS; 	
} */

/*********************************************************************************************************/


TLViewController.viewScaleSettings["day-medium-hour"] = {
	getStageWidthRatio: function() {
		return 64/AJKHelpers.dateOneHourInMS; // 64 = the width of one hour in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time:aDate.getTime() });
		retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time:blockStartDate.getTime()+AJKHelpers.dateOneDayInMS});
		//retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		if (aDate.getHours() > 20) {
			aDate.setTime(aDate.getTime()+AJKHelpers.dateOneDayInMS);
			aDate.setHours(0);
		}
		return aDate.getDate()+" "+AJKHelpers.dateMonthsShortArray[aDate.getMonth()];
	}
}

TLViewController.viewScaleSettings["day-large-hour"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["day-medium-hour"] }); 
TLViewController.viewScaleSettings["day-large-hour"].getStageWidthRatio = function() {
	return 128/AJKHelpers.dateOneHourInMS; // 128 = the width of one hour in this mode	
}

TLViewController.viewScaleSettings["day-small-hour"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["day-medium-hour"] }); 
TLViewController.viewScaleSettings["day-small-hour"].getStageWidthRatio = function() {
	return 32/AJKHelpers.dateOneHourInMS; // 32 = the width of one hour in this mode	
}

TLViewController.viewScaleSettings["day-tiny-hour"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["day-medium-hour"] }); 
TLViewController.viewScaleSettings["day-tiny-hour"].getStageWidthRatio = function() {
	return 16/AJKHelpers.dateOneHourInMS; // 16 = the width of one hour in this mode	
}

TLViewController.viewScaleSettings["day-tincy-hour"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["day-medium-hour"] }); 
TLViewController.viewScaleSettings["day-tincy-hour"].getStageWidthRatio = function() {
	return 256/AJKHelpers.dateOneDayInMS; // 256 = the width of one day in this mode	
}


/*********************************************************************************************************/


TLViewController.viewScaleSettings["month-small-day"] = {
	getStageWidthRatio: function() {
		return 64/AJKHelpers.dateOneDayInMS; // 64 = the width of one day in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time:aDate.getTime()});
		retDate.setDate(1);
		retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time:blockStartDate.getTime()});
		var sMonth = blockStartDate.getMonth();
		var sYear = blockStartDate.getFullYear();
		if (sMonth == 11) {
			sMonth = 0;
			sYear++;
		}
		else {
			sMonth++;	
		}
		retDate.setMonth(sMonth);
		retDate.setFullYear(sYear);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		return AJKHelpers.dateMonthsShortArray[aDate.getMonth()]+" '"+AJKHelpers.doubleDigitNum({num: aDate.getFullYear() % 100});
	},
	displayDateFormat: "ddnn MMMM YYYY",
	offsetNextZebra: false,
	offsetWidth: 64,
	adjustDomBlock: function(data) {
		var domBlock = data.domBlock;
		var date = data.date;

		if (this.offsetNextZebra) {
			$(domBlock).css({ backgroundPosition: "-"+(this.offsetWidth+1)+"px  0"});
			//this.offsetNextZebra=false;
		}
				
		var numberOfDaysInMonth = AJKHelpers.numberOfDaysInMonth({ aDate: date });
		if (numberOfDaysInMonth % 2) {
			this.offsetNextZebra = !this.offsetNextZebra;	
		}
	}
}

TLViewController.viewScaleSettings["month-medium-day"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["month-small-day"] }); 
TLViewController.viewScaleSettings["month-medium-day"].offsetWidth = 128;
TLViewController.viewScaleSettings["month-medium-day"].getStageWidthRatio = function() {
	return 128/AJKHelpers.dateOneDayInMS; // 128 = the width of one day in this mode	
}

TLViewController.viewScaleSettings["month-tiny-day"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["month-small-day"] }); 
TLViewController.viewScaleSettings["month-tiny-day"].offsetWidth = 21;
TLViewController.viewScaleSettings["month-tiny-day"].getStageWidthRatio = function() {
	return 21/AJKHelpers.dateOneDayInMS; // 21 = the width of one day in this mode	
}

TLViewController.viewScaleSettings["month-tincy-day"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["month-small-day"] }); 
TLViewController.viewScaleSettings["month-tincy-day"].offsetWidth = 0;
TLViewController.viewScaleSettings["month-tincy-day"].getStageWidthRatio = function() {
	return 12.8/AJKHelpers.dateOneDayInMS; // 12.8 = the width of one day in this mode	
}

/*********************************************************************************************************/

TLViewController.viewScaleSettings["year-medium-month"] = {
	getStageWidthRatio: function() {
		return 768/AJKHelpers.dateOneYearInMS; // 768 = the width of one years in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time:aDate.getTime() });
		retDate.setMonth(0);
		retDate.setDate(1);
		retDate.setHours(0);
		retDate.setMinutes(1);
		retDate.setSeconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time:blockStartDate.getTime() });
		retDate.setFullYear(blockStartDate.getFullYear()+1);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var self = this;
		var aDate = data.date;	
		if (data.subItem) {
			var newDate = new Date();
			newDate.setTime(aDate.getTime() + (AJKHelpers.dateOneDayInMS * 2)); // Deal with rounding
			var formatString = (self.segmentWidth < 128) ? "MMM" : (self.segmentWidth < 256) ? "MMMM" : "MMMM YYYY";
			return AJKHelpers.formatDate({ date: newDate, formatString: formatString });
		}
		else {
			return AJKHelpers.formatFullYearForDate({ date: aDate });
		}
	},
	displayDateFormat: "MMMM YYYY",
	numItems: 12,
	segmentWidth: 64
}
	
TLViewController.viewScaleSettings["year-very-large-month"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["year-medium-month"] }); 
TLViewController.viewScaleSettings["year-very-large-month"].getStageWidthRatio = function() {
	return 3072/AJKHelpers.dateOneYearInMS; // 3072 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["year-very-large-month"].segmentWidth = 256;

TLViewController.viewScaleSettings["year-large-month"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["year-medium-month"] }); 
TLViewController.viewScaleSettings["year-large-month"].getStageWidthRatio = function() {
	return 1536/AJKHelpers.dateOneYearInMS; // 1536 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["year-large-month"].segmentWidth = 128;

TLViewController.viewScaleSettings["year-small-month"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["year-medium-month"] }); 
TLViewController.viewScaleSettings["year-small-month"].getStageWidthRatio = function() {
	return 384/AJKHelpers.dateOneYearInMS; // 384 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["year-small-month"].numItems = 6;

TLViewController.viewScaleSettings["year-tiny-month"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["year-medium-month"] }); 
TLViewController.viewScaleSettings["year-tiny-month"].getStageWidthRatio = function() {
	return 252/AJKHelpers.dateOneYearInMS; // 252 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["year-tiny-month"].numItems = 4;
TLViewController.viewScaleSettings["year-tiny-month"].segmentWidth = 64;

/*********************************************************************************************************/

TLViewController.viewScaleSettings["decade-medium-year"] = {
	getStageWidthRatio: function() {
		return 64/AJKHelpers.dateOneYearInMS; // 6 = the width of one years in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate =AJKHelpers.createDateWithTime({ time: aDate.getTime() });
		var aYear = retDate.getFullYear();
		if (aYear < 0) {
			if (aYear % 10 == 0) {
				var roundedYear = aYear;
			}
			else {
				var roundedYear = parseInt(aYear / 10) * 10 -10;
			}
		}
		else {
			var roundedYear = parseInt(aYear / 10) * 10;
		}
		retDate.setFullYear(roundedYear);
		retDate.setMonth(1);
		retDate.setDate(1);
		retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time:blockStartDate.getTime() });
		retDate.setFullYear(blockStartDate.getFullYear()+10);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		return AJKHelpers.formatFullYearForDate({ date: aDate });
	},
	displayDateFormat: "YYYY",
	numItems: 10,
	segmentWidth: 64
}

TLViewController.viewScaleSettings["decade-large-year"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["decade-medium-year"] }); 
TLViewController.viewScaleSettings["decade-large-year"].getStageWidthRatio = function() {
	return 128/AJKHelpers.dateOneYearInMS; // 128 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["decade-large-year"].segmentWidth=128;

TLViewController.viewScaleSettings["decade-small-year"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["decade-medium-year"] }); 
TLViewController.viewScaleSettings["decade-small-year"].getStageWidthRatio = function() {
	return 32/AJKHelpers.dateOneYearInMS; // 128 = the width of one years in this mode	
}
TLViewController.viewScaleSettings["decade-small-year"].segmentWidth=64;
TLViewController.viewScaleSettings["decade-small-year"].numItems=5;

/*********************************************************************************************************/

TLViewController.viewScaleSettings["century-large-decade"] = {
	getStageWidthRatio: function() {
		return 25.6/AJKHelpers.dateOneYearInMS; // 256 = the width of one years in this mode	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time: aDate.getTime() });
		var aYear = retDate.getFullYear();
		if (aYear < 0) {
			if (aYear % 100 == 0) {
				var roundedYear = aYear;
			}
			else {
				var roundedYear = parseInt(aYear / 100) * 100 -100;
			}
		}
		else {
			var roundedYear = parseInt(aYear / 100) * 100;
		}
		retDate.setFullYear(roundedYear);
		retDate.setMonth(1);
		retDate.setDate(1);
		retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time: blockStartDate.getTime() });
		retDate.setFullYear(blockStartDate.getFullYear()+100);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		var fullYear = aDate.getFullYear();
		if (fullYear >= 0) {
			var roundedFullYear = parseInt((fullYear+1)/10) * 10;
		}
		else {
			var roundedFullYear = parseInt((fullYear-1)/10) * 10;
		}
		aDate.setFullYear(roundedFullYear);
		return AJKHelpers.formatFullYearForDate({ date: aDate });
	},
	displayDateFormat: "YYYY",
	numItems: 10,
	segmentWidth: 256
}

TLViewController.viewScaleSettings["century-medium-decade"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["century-large-decade"] }); 
TLViewController.viewScaleSettings["century-medium-decade"].getStageWidthRatio = function() {
	return 12.8/AJKHelpers.dateOneYearInMS;	
}
TLViewController.viewScaleSettings["century-medium-decade"].segmentWidth=128;

TLViewController.viewScaleSettings["century-small-decade"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["century-large-decade"] }); 
TLViewController.viewScaleSettings["century-small-decade"].getStageWidthRatio = function() {
	return 6.4/AJKHelpers.dateOneYearInMS; 	
}
TLViewController.viewScaleSettings["century-small-decade"].segmentWidth=64;

TLViewController.viewScaleSettings["century-tiny-decade"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["century-large-decade"] }); 
TLViewController.viewScaleSettings["century-tiny-decade"].getStageWidthRatio = function() {
	return 3.2/AJKHelpers.dateOneYearInMS; 	
}
TLViewController.viewScaleSettings["century-tiny-decade"].segmentWidth=64;
TLViewController.viewScaleSettings["century-tiny-decade"].numItems=5;

/*********************************************************************************************************/

TLViewController.viewScaleSettings["millenium-large-century"] = {
	getStageWidthRatio: function() {
		return 256*100/AJKHelpers.dateOneYearInMS/10000;	
	},
	getFirstBlockStartDateFromDate: function(data) {
		var aDate = data.date;
		var retDate = AJKHelpers.createDateWithTime({ time: aDate.getTime() });
		var aYear = retDate.getFullYear();
		if (aYear < 0) {
			if (aYear % 1000 == 0) {
				var roundedYear = aYear;
			}
			else {
				var roundedYear = parseInt(aYear / this.blockDateRange) * this.blockDateRange -this.blockDateRange;
			}
		}
		else {
			var roundedYear = parseInt(aYear / this.blockDateRange) * this.blockDateRange;
		}
		retDate.setFullYear(roundedYear);
		retDate.setMonth(1);
		retDate.setDate(1);
		retDate.setHours(0);
		retDate.setMinutes(0);
		retDate.setSeconds(0);
		retDate.setMilliseconds(0);
		return retDate;
	},
	getDateRangeInMS: function(data) {
		var blockStartDate = data.blockStartDate;
		var retDate = AJKHelpers.createDateWithTime({ time: blockStartDate.getTime() });
		retDate.setFullYear(blockStartDate.getFullYear()+this.blockDateRange);
		return retDate.getTime()-blockStartDate.getTime();
	},
	getTextForDate: function(data) {
		var aDate = data.date;	
		var fullYear = aDate.getFullYear();
		if (fullYear >= 0) {
			var roundedFullYear = parseInt((fullYear+(this.blockDateRange/100))/(this.blockDateRange/10)) * (this.blockDateRange/10);
		}
		else {
			var roundedFullYear = parseInt((fullYear-(this.blockDateRange/100))/(this.blockDateRange/10)) * (this.blockDateRange/10);
		}
		aDate.setFullYear(roundedFullYear);
		return AJKHelpers.formatFullYearForDate({ date: aDate });
	},
	blockDateRange: 1000,
	displayDateFormat: "YYYY",
	numItems: 10,
	segmentWidth: 256
}

TLViewController.viewScaleSettings["millenium-medium-century"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["millenium-large-century"] }); 
TLViewController.viewScaleSettings["millenium-medium-century"].getStageWidthRatio = function() {
		return 128*100/AJKHelpers.dateOneYearInMS/10000;	
}
TLViewController.viewScaleSettings["millenium-medium-century"].segmentWidth=128;

/*TLViewController.viewScaleSettings["millenium-small-century"] = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["millenium-large-century"] }); 
TLViewController.viewScaleSettings["millenium-small-century"].getStageWidthRatio = function() {
		return 64*100/AJKHelpers.dateOneYearInMS/10000;	
}
TLViewController.viewScaleSettings["millenium-small-century"].segmentWidth=64; */

(function() {
	/* Initial views for longer periods */
	var TLSCPDiv = 10000;
	var TLSCPMult = 2;
	var TLSCPBlueprint = AJKHelpers.cloneObj({ obj: TLViewController.viewScaleSettings["millenium-large-century"] });
	TLSCPBlueprint.segmentWidth = 128;
	var TLSCPNamePrefix = "large-date-range-";
	var TLSCPInterations = 30;
	var TLSCOMultipliers = [2,5,10];
	 
	for (var counter = 0; counter < TLSCPInterations; counter++) {
		var scaleName = "large-date-range-"+counter;
		var scale = AJKHelpers.cloneObj({ obj: TLSCPBlueprint });
		//console.log(Math.pow(TLSCPMult, counter+1) * TLSCPDiv); //uncomment to spit out rough values
		//scale.largeDivider = TLSCPCachedDivs[counter];
		scale.largeDivider = TLSCOMultipliers[counter % 3] * Math.pow(10,parseInt(counter/3)) * TLSCPDiv;
		//console.log(scale.largeDivider);
		scale.blockDateRange = scale.largeDivider/10;
		scale.getStageWidthRatio = function() {
			var self = this;
			return 128*100/AJKHelpers.dateOneYearInMS/self.largeDivider;	
		}
		TLViewController.viewScaleSettings[scaleName] = scale;
	}
})();