/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/


var TLYouTubeFeedHelper = {
	defautNumVideos: 20,
	defaultThumbImage: "/assets/ui/youtube-default-thumb.jpg",
	getVideosForFeed: function(data) {
		var feed = data.feed;
		var callback = data.callback;
		var numItems = (feed.numItems > 50) ? 50 : feed.numItems;
		
		if (feed.filter == "youtube-username") {
			TLYouTubeFeedHelper.getVideosFromUsername({
				numVideos: numItems,
				startIndex: 1,
				username: feed.param1,
				callback: function(data) {
					callback({
						videos: data.itemObjs	
					});
				}
			});
		}
		else if (feed.filter == "youtube-search") {
			TLYouTubeFeedHelper.getVideosForSearchTerm({
				numVideos: numItems,
				startIndex: 1,
				searchTerm: feed.param1,
				callback: function(data) {
					callback({
						videos: data.itemObjs	
					});
				}
			});
		}
		else {
			var feedType = feed.filter.split("youtube-")[1];
			TLYouTubeFeedHelper.getVideosForStandardFeedOfType({
				type: feedType,
				numVideos: numItems,
				startIndex: 1,
				callback: function(data) {
					callback({
						videos: data.itemObjs	
					});
				}
			});
		}
	},
	getVideosFromUsername: function(data) {
		var callback = data.callback;
		$.getJSON("https://gdata.youtube.com/feeds/api/users/"+data.username+"/uploads"+"?callback=?", {
			"start-index": data.startIndex,
			"max-results": data.numVideos,
			"v": 2,
			"alt": "json"
		}, function(data) {
			TLYouTubeFeedHelper.feedLoadFunc({
				callback: callback,
				feedData: data	
			}); 
		});
	},
	getVideosForStandardFeedOfType: function(data) {
		var callback = data.callback;
		$.getJSON("https://gdata.youtube.com/feeds/api/standardfeeds/"+data.type+"?callback=?", {
			"start-index": data.startIndex,
			"max-results": data.numVideos,
			"v": 2,
			"alt": "json",
			"orderby": "published"
		}, function(data) {
			TLYouTubeFeedHelper.feedLoadFunc({
				callback: callback,
				feedData: data	
			}); 
		});
	},
	getVideosForSearchTerm: function(data) {
		var callback = data.callback;
		$.getJSON("http://gdata.youtube.com/feeds/api/videos"+"?callback=?", {
			"q": data.searchTerm,
			"start-index": data.startIndex,
			"max-results": data.numVideos,
			"v": 2,
			"alt": "json",
			"orderby": "published"
		}, function(data) {
			TLYouTubeFeedHelper.feedLoadFunc({
				callback: callback,
				feedData: data	
			}); 
		});
	},
	feedLoadFunc: function(data) {
		var callback = data.callback;
		var feedData = data.feedData;
		if (!feedData || !feedData.feed || !feedData.feed.entry) {
			return;	
		}
		var returnObjs = TLYouTubeFeedHelper.processJSONFromArray({
			anArray: feedData.feed.entry	
		});
		callback({ itemObjs: returnObjs });	
	},
	processJSONFromArray: function(data) {
		var anArray = data.anArray;
		var returnObjs = new Array();
		var counter = 0;
		if (!anArray) {
			return [];	
		}
		$.each(anArray, function() {
			if (this["media$group"] && this["media$group"]["media$description"] && this["media$group"]["media$description"].type == "plain") {
				var description = this["media$group"]["media$description"]["$t"];
			}
			else {
				var description = "";
			}
			var thumbImage =  (this["media$group"]["media$thumbnail"]) ? this["media$group"]["media$thumbnail"][1] || this["media$group"]["media$thumbnail"][0] : { url: TLYouTubeFeedHelper.defaultThumbImage }; 
			
			var aDate =  this.published["$t"];
			aDate = aDate.replace("T"," ").replace(".000Z","");
			var anObj = {
				id: this.id["$t"].split("video:")[1],
				owner: this.author[0].name["$t"],
				title: this.title["$t"],
				description: description,
				url: this.link[0].href,
				image: thumbImage.url,
				ownername: this.author[0].name["$t"],
				date: AJKHelpers.dateFromMySQLDate({ dateString: aDate }),
				index: counter++
			}
			returnObjs.push(anObj);
		});		
		return returnObjs;
	}
}