/* Copyright 2013 Webalon Ltd
 *
 * It is strictly forbidden to copy, distribute, modify or reuse this file or its
 * contents without written permission from the copyright holder, Webalon Ltd
 *
 **************************************************************************************/

var TLDTSaveFader = function(data) {
	var self = this;
	self.domRoot = $("#tldt-timeline-footer").get()[0];
	self.domFader = $("#tldt-timeline-footer").find(".fader").get()[0];	
	self.domBar = $(self.domRoot).find(".fader-bar").get()[0];
	self.domDefaultMessage = $(self.domRoot).find(".status-default").get()[0];
	self.domSaveNeededMessage = $(self.domRoot).find(".status-save-needed").get()[0];
}

TLDTSaveFader.prototype = {
	init: function() {
		var self = this;
		return self;	
	},
	showMessageSaveNeeded: function() {
		var self = this;
		//$(self.domDefaultMessage).css({ display: "none" });
		//$(self.domSaveNeededMessage).css({ display: "inline" });
	},
	showMessageDefault: function() {
		var self = this;
		//$(self.domDefaultMessage).css({ display: "inline" });
		//$(self.domSaveNeededMessage).css({ display: "none" });
	},
	fadeOut: function(data) {
		var self = this;
		var callback = (data) ? data.callback : false;
		$(self.domFader).animate({ opacity: 0}, 500, function() {
			$(this).css({ display: "none" });	
			if (callback) {
				callback();	
			}
		});	
	},
	fadeIn: function(data) {
		var self = this;
		var callback = (data) ? data.callback : false;
		$(self.domFader).css({ opacity: 0, display: "block" });
		$(self.domBar).css({ width: 0 });
		$(self.domFader).animate({ opacity: 1}, 500, function() {
			if (callback) {
				callback();	
			}
		});
	},
	animateProgressTo: function(data) {
		var self = this;
		var percent = data.percent;
		var callback = (data) ? data.callback : false;
		$(self.domBar).animate({ width: "100%" }, 1000, function() {
			if (callback) {
				callback();	
			}
		});
		
	},
	executeProgress: function(data) {
		var self = this;
		var callback = (data) ? data.callback : false;
		self.fadeIn({
			callback: function() {
				self.animateProgressTo({ 
					percent: 100,
					callback: function() {
						self.fadeOut({
							callback: function() {
								if (callback) {
									callback();	
								}
							}
						});
					}
				 });	
			}
		});
	}
	
	
}

var TLNewTimelineData = 'var TLTimelineData = {"host":"timeline","homePage":false,"showAdBlock":"false","id":87752,"title":"New Timeline","urlFriendlyTitle":"New-Timeline","startDate":"2010-01-01 00:00:00","endDate":"2020-01-01 00:00:00","introText":"","aboutText":"","introImage":"","authorName":"Me","accountType":"Teacher","backgroundImage":"","introImageCredit":"","backgroundImageCredit":"","feed":"","mainColour":"A879BE","zoom":"","initialFocus":"first","embedHash":"7546004423","embed":"true","secret":"false","public":"yes","dontDisplayIntroPanel":1,"openReadMoreLinks":1,"storyDateStatus":0,"storySpacing":0,"viewType":0,"showTitleBlock":1,"backgroundColour":"1A1A1A","storyDateFormat":"auto","topDateFormat":"auto","sliderDateFormat":"auto","language":"english","displayStripes":1,"htmlFormatting":0,"sliderBackgroundColour":"000000","sliderTextColour":"808080","sliderDetailsColour":"282828","sliderDraggerColour":"808080","headerBackgroundColour":"000000","headerTextColour":"808080","showGroupAuthorNames":"1","durHeadlineColour":"ffffff","cssFile":"","altFlickrImageUrl":"","fontBase":"default","fontHead":"default","fontBody":"default","lightboxStyle":"0","showControls":"0","lazyLoading":"1","expander":"2","settings3d":"1,ffffff,0.25,883,0.1125,1.25,1,3,0.25","categories":[],"feeds":[],"stories":[]}';

var theTLDTSaveFader = "";
var tlIFrame = "";
var tlIFrameLoaded = false;
var TLLoadTimelineFromData = function(timelineData) {
    var isNew = (timelineData == "new");
	timelineData = (timelineData == "new") ? TLNewTimelineData : timelineData;
	if (tlIFrameLoaded) {
		tlIFrame.contentWindow.postMessage({
          type: "file-load",
          timelineData: timelineData,
          filePath: "test-path",
          isNew: isNew
        }, '*');
	}
	else {
		var thisFunc = arguments.callee;
		setTimeout( function() {
			thisFunc(timelineData);
		},25);	
	}
	return;
}

var TLGetTimelineDataForSave = function() {
	return tlIFrame.contentWindow.theTLMainController.getTimelineDataAsString();
}

var TLGetTimelineWidth = function() {
	return Math.round(tlIFrame.contentWindow.theTLMainController.selectedView.width);
}

var TLTimelineWasSavedToFile = function() {
	theTLDTSaveFader.executeProgress();			
	setTimeout( function() {
		theTLDTSaveFader.showMessageDefault();
	},501);
}

var TLImageWasChosenForTimeline = function(imagePath) {
	//$("#console").append(imagePath);
	var uploadImageSelector = tlIFrame.contentWindow.theTLMainController.adminController.imageSelector.selectors["upload"];
	uploadImageSelector.userSelectedImage({ imagePath: imagePath });
}

var TLVideoWasChosenForTimeline = function(videoPath) {
	//$("#console").append(imagePath);
	var uploadVideoSelector = tlIFrame.contentWindow.theTLMainController.adminController.videoSelector.selectors["upload"];
	uploadVideoSelector.userSelectedVideo({ videoPath: videoPath });
}

$(document).ready( function() {
	var domSaveButton = $("#tl-timeline-save").get()[0];
	var domSaveAsButton = $("#tl-timeline-save-as").get()[0];

	tlIFrame = $("#tl-timeline-iframe").get()[0];
	
	if (typeof TLDynamicallyResizeTimelineIFrame != "undefined" && TLDynamicallyResizeTimelineIFrame) {
		new TLIFrameResizer({
			domIFrame: tlIFrame
		}).init();
			
	}
	
    $(".promo-message a").click( function() {
        window.NSDocument.openAppPage();
        return false;
    });
                  
    theTLDTSaveFader = new TLDTSaveFader().init();
	
	$(tlIFrame).load( function() {
		tlIFrameLoaded = true;
		$(domSaveButton).click( function() {
			//window.NSDocument.invokeSave();
			return false;
		});
		
		$(domSaveAsButton).click( function() {
			//window.NSDocument.invokeSaveAs();
			return false;
		});
		
    });
	
	// Inititalise receive messages for window
	window.addEventListener('message', function(e) {
		if (e.data.type == "save-status") {
			var savedStatus = e.data.saveStatus;
			if (savedStatus == "save-needed") {
				theTLDTSaveFader.showMessageSaveNeeded();
			}
			else {
				theTLDTSaveFader.showMessageDefault();
			}
			
		}
	});
});

var TLIFrameResizer = function(data) {
	var self = this;
	self.domIFrame = data.domIFrame; 	
}

TLIFrameResizer.prototype = {
	init: function() {
		var self = this;
		$(window).resize( function() {
			self.resize();
		});
		self.resize();
		return self;	
	},
	resize: function() {
		var self = this;
		var viewportHeight = window.innerHeight;
		viewportHeight -= 37;
		viewportHeight = (viewportHeight < 0) ? 0 : viewportHeight;
		$(self.domIFrame).css({ height: viewportHeight }).attr("height",viewportHeight);
	}
}

