var writeableEntries = [];

window.saveFileForPath = function(data) {
	var path = data.path;
	var fileEntry = writeableEntries[path];
	var timelineData = data.timelineData;

	var blob = new Blob([timelineData], {type: 'text/plain'});
	writeFileEntry(fileEntry, blob, function(e) {
		//console.log("file saved and written");
	});
}

window.storeWritableEntryForPath = function(data) {
	var path = data.path;
	var writeableEntry = data.fileEntry;
	writeableEntries[path] = writeableEntry
}

var launchTimeline = function(data) {
	var timelineData = data.timelineData;
	var filePath = data.filePath
	chrome.app.window.create('timeline-window.html', {
		'width': 1100,
		'height': 700,
		type: 'panel'
	}, function(win) {
		var timelineWin = win;
		var winDocument = timelineWin.contentWindow.document;
		timelineWin.contentWindow.TLMasterWindow = window;
		
		$(winDocument).ready( function() {
			var tlIFrame = winDocument.getElementById("tl-timeline-iframe");
			if (!tlIFrame) {
				var thisFunc = arguments.callee;
				setTimeout( function() {
					thisFunc();
				},10);
				return;	
			}
			var iFrameFuncCalled = false;
			var iFrameLoadedFunc = function() {
				if (iFrameFuncCalled) {
					return;	
				}
				iFrameFuncCalled = true;
				setTimeout( function() {
					tlIFrame.contentWindow.postMessage({
						type: "file-load",
						timelineData: timelineData,
						filePath: filePath
					}, '*');
				},1);
			}
			// Initialise and load timeline iframe with data
			$(tlIFrame).load( function() {
				iFrameLoadedFunc();
			});
			
			/* setTimeout( function() {
				iFrameLoadedFunc();
			},200);*/
				
		});
		
	});
	
} 


$(document).ready( function() {
	
	$("#tl-open-file").click( function() {
		
		chrome.fileSystem.chooseEntry({
			type: 'openWritableFile',
			acceptsAllTypes: false,
			accepts: [{
				extensions: ["tki"]
			}]
		}, function(writableEntry) {
			
			writeableEntries[writableEntry.fullPath] = writableEntry;
			
			writableEntry.file(function(file) {
				var reader = new FileReader();
				var timelineWin = "";
				reader.onerror = function() {};
				reader.onloadend = function(e) {
					launchTimeline({
						timelineData: e.target.result,
						filePath: writableEntry.fullPath
					});
				};
				
				reader.readAsText(file);
			});
		});
		return false;
	});
	

	$("#tl-new-timeline").click( function() {
		launchTimeline({
			timelineData: tlStringedTimelineData,
			filePath: ""
		});
	});

});

var TLTimelineData = {
	"host": "timeline",
	"homePage": false, 
	"showAdBlock": "false", 
	"id":87752,
	"title":"New Timeline",
	"urlFriendlyTitle":"New-Timeline",
	"startDate":"2000-01-01 00:00:00",
	"endDate":"2011-01-01 00:00:00",
	"introText":"",
	"aboutText":"",
	"introImage":"",
	"authorName":"Alex Kearns",
	"accountType":"Teacher",
	"backgroundImage":"",
	"introImageCredit":"",
	"backgroundImageCredit":"",
	"feed": "",
	"mainColour": "A879BE",
	"zoom": "",
	"initialFocus": "first",
	"embedHash": "7546004423",
	"embed": "true",
	"secret": "false",
	"public": "yes",
	"dontDisplayIntroPanel": 0,
	"openReadMoreLinks": 1,
	"storyDateStatus": 0,
	"storySpacing": 0,
	"viewType": 0,
	"showTitleBlock": 1,
	"backgroundColour": "1A1A1A",
	"storyDateFormat": "auto",
	"topDateFormat": "auto",
	"sliderDateFormat": "auto",
	"language": "english",
	"displayStripes": 1,
	"htmlFormatting": 0,
	"sliderBackgroundColour": "000000",
	"sliderTextColour": "808080",
	"sliderDetailsColour": "282828",
	"sliderDraggerColour": "808080",
	"headerBackgroundColour": "000000",
	"headerTextColour": "808080",
	"showGroupAuthorNames": "1",
	"durHeadlineColour": "ffffff",
	"cssFile": "",
	"altFlickrImageUrl": "",
	"fontBase": 'default',
	"fontHead": 'default',
	"fontBody": 'default',
	"lightboxStyle": '0',
	"showControls": '0',
	"lazyLoading": '1',
	"expander": "2",
	"categories":[],			
	"feeds":[],			
	"stories":[]
}

var tlStringedTimelineData = 'var TLTimelineData = {"host":"timeline","homePage":false,"showAdBlock":"false","id":87752,"title":"New Timeline","urlFriendlyTitle":"New-Timeline","startDate":"2000-01-01 00:00:00","endDate":"2011-01-01 00:00:00","introText":"","aboutText":"","introImage":"","authorName":"Alex Kearns","accountType":"Teacher","backgroundImage":"","introImageCredit":"","backgroundImageCredit":"","feed":"","mainColour":"A879BE","zoom":"","initialFocus":"first","embedHash":"7546004423","embed":"true","secret":"false","public":"yes","dontDisplayIntroPanel":1,"openReadMoreLinks":1,"storyDateStatus":0,"storySpacing":0,"viewType":0,"showTitleBlock":1,"backgroundColour":"1A1A1A","storyDateFormat":"auto","topDateFormat":"auto","sliderDateFormat":"auto","language":"english","displayStripes":1,"htmlFormatting":0,"sliderBackgroundColour":"000000","sliderTextColour":"808080","sliderDetailsColour":"282828","sliderDraggerColour":"808080","headerBackgroundColour":"000000","headerTextColour":"808080","showGroupAuthorNames":"1","durHeadlineColour":"ffffff","cssFile":"","altFlickrImageUrl":"","fontBase":"default","fontHead":"default","fontBody":"default","lightboxStyle":"0","showControls":"0","lazyLoading":"1","expander":"2","categories":[],"feeds":[],"stories":[]}';

//var tlStringedTimelineData = 'var TLTimelineData = {"host":"","homePage":false,"showAdBlock":"false","id":78207,"title":"Category Band Duration","urlFriendlyTitle":"Category-Band-Duration","startDate":"2012-01-01 00:00:00","endDate":"2013-01-01 00:00:00","introText":"You can now display events over a duration using the Category Band view.","aboutText":"A few weeks ago we launched new features that allow much greater customisation of Category Band timelines* - see [here](/timeline/entry/55584/New-Category-Band-features/). Now, we have improved the Category Band view still further, by allowing you to choose whether stories in a particular category band should appear as the standard white bubble or as coloured duration bars. This opens up the possibility of creating more varied and powerful timelines.;xNLx;;xNLx;To activate the duration layout for a particular category band, firstly choose the category in the admin interface, by selecting the Category tab and then clicking on an existing category. Alternatively, create a new category. You will notice that there are now some new options specifically for the Category Band view. Choose \'Duration\' as the layout option, and click save. Now all stories in that category will appear as coloured bars (if their end date is different to their start date) or as smaller coloured bubbles.;xNLx;;xNLx;You can also choose how many rows the duration stories should be laid our over for a particular category. We hope you like this new feature!;xNLx;;xNLx;* For those who have not yet used the Category Band option, this view splits the timeline into vertical bands for each category that you create. You can activate it for a timeline via the \'View type\' option in the Setting\'s tab.","introImage":"http://d8lktyzx0qqvd.cloudfront.net/timelines/67/3468296614_9df7b84498_m.jpg","authorName":"Alex Kearns","accountType":"Teacher","backgroundImage":"","introImageCredit":"","backgroundImageCredit":"","feed":"","mainColour":"8C3FA6","zoom":"month-small-day","initialFocus":"first","embedHash":"3134820620","embed":"true","secret":"false","public":"yes","dontDisplayIntroPanel":1,"openReadMoreLinks":1,"storyDateStatus":0,"storySpacing":0,"viewType":1,"showTitleBlock":0,"backgroundColour":"1A1A1A","storyDateFormat":"auto","topDateFormat":"auto","sliderDateFormat":"auto","language":"english","displayStripes":1,"htmlFormatting":0,"sliderBackgroundColour":"000000","sliderTextColour":"808080","sliderDetailsColour":"282828","sliderDraggerColour":"808080","headerBackgroundColour":"000000","headerTextColour":"808080","showGroupAuthorNames":"1","durHeadlineColour":"ffffff","cssFile":"","altFlickrImageUrl":"","fontBase":"default","fontHead":"default","fontBody":"default","lightboxStyle":"1","showControls":"1","lazyLoading":"1","categories":[{"id":54546,"title":"Main Timeline","colour":"E0BE26","layout":"0","rows":"3","order":"10","size":"40"},{"id":54547,"title":"Sub Timeline 1","colour":"F7582D","layout":"1","rows":"2","order":"10","size":"10"},{"id":54548,"title":"Sub Timeline 2","colour":"ED216C","layout":"1","rows":"2","order":"10","size":"10"}],"feeds":[],"stories":[{"id":714415,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-01 00:00:00","endDate":"2012-01-01 00:00:00","text":"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","fullText":"","category":"54546","dateFormat":"auto","externalLink":"","media":[{"id":336097,"src":"http://d8lktyzx0qqvd.cloudfront.net/timelines/67/3340434557_9a54722ec7_m.jpg","caption":"","type":"Image","thumbPosition":"0,0","externalMediaThumb":"","externalMediaType":"","externalMediaId":"","orderIndex":10},{"id":693,"src":"http://vimeo.com/18008261","caption":"","type":"Video","thumbPosition":"0,0","externalMediaThumb":"http://b.vimeocdn.com/ts/126/023/126023542_640.jpg","externalMediaType":"vimeo","externalMediaId":"18008261","orderIndex":10}]},{"id":714416,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-05 00:00:00","endDate":"2012-01-05 00:00:00","text":"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","fullText":"","category":"54546","dateFormat":"auto","externalLink":"","media":[{"id":336098,"src":"http://d8lktyzx0qqvd.cloudfront.net/timelines/67/5484921017_29983758fb_m.jpg","caption":"","type":"Image","thumbPosition":"0,0","externalMediaThumb":"","externalMediaType":"","externalMediaId":"","orderIndex":10}]},{"id":714417,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-11 00:00:00","endDate":"2012-01-11 00:00:00","text":"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","fullText":"","category":"54546","dateFormat":"auto","externalLink":"","media":[]},{"id":714418,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-15 00:00:00","endDate":"2012-01-15 00:00:00","text":"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","fullText":"","category":"54546","dateFormat":"auto","externalLink":"","media":[{"id":336099,"src":"http://d8lktyzx0qqvd.cloudfront.net/timelines/67/5484921309_0c4e4a135b_m.jpg","caption":"","type":"Image","thumbPosition":"0,0","externalMediaThumb":"","externalMediaType":"","externalMediaId":"","orderIndex":10}]},{"id":714419,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-05 00:00:00","endDate":"2012-01-15 00:00:00","text":"Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.","fullText":"","category":"54547","dateFormat":"auto","externalLink":"","media":[]},{"id":714420,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-01 00:00:00","endDate":"2012-01-10 00:00:00","text":"Enter story info here","fullText":"","category":"54547","dateFormat":"auto","externalLink":"","media":[]},{"id":714421,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-15 00:00:00","endDate":"2012-01-20 00:00:00","text":"Enter story info here","fullText":"","category":"54547","dateFormat":"auto","externalLink":"","media":[]},{"id":714422,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-05 00:00:00","endDate":"2012-01-10 00:00:00","text":"Enter story info here","fullText":"","category":"54548","dateFormat":"auto","externalLink":"","media":[]},{"id":714423,"ownerId":"19","ownerName":"","title":"Lorem ipsum","startDate":"2012-01-11 00:26:24","endDate":"2012-01-15 00:26:24","text":"Enter story info here","fullText":"","category":"54548","dateFormat":"auto","externalLink":"","media":[]}]}';

